package Freenet;
/*
  This code is part of the Java Adaptive Network Client by Ian Clarke. 
  It is distributed under the GNU General Public Licence (GPL) 
  version 2.  See http://www.gnu.org/ for further details of the GPL.
 */

/**
 * This class stores relevant information about a message
 * so that if another message is received with the same ID
 * the node will know how to handle it.
 *
 * @author <A HREF="mailto:I.Clarke@strs.co.uk">Ian Clarke</A>
 * @author <A HREF="mailto:author2@email.addr">Author 2</A>
 **/

public class MessageMemory
{
  public MessageMemory(Address addr, long dpth)
  {
    origRec=addr;
    depth = dpth;
  }

    public MessageMemory(Address origRec, long depth, ConnectionHandler replyCon)
    {
	this.origRec = origRec;
	this.depth = depth;
	this.replyCon = replyCon;
    }

  /** The address that the original message was received from **/
  public Address origRec;
    public long depth;
    public ConnectionHandler replyCon;

    /** A method called if this messagememory is lost from the datastore due to overflow **/
    public void lost(Long longid) {}

    public String toString() {
	return "origRec: " + origRec + " depth: " + depth;
    }

}
