package Freenet.client;

import Freenet.*;
import Freenet.Params;
import Freenet.FieldSet;
import Freenet.support.*;
import Freenet.support.io.*;
import java.io.*;
import java.util.*;

/** @deprecated */
public class MapFile
{
    private FieldSet fs = new FieldSet();
    public long atime = new Date().getTime();

    /**
     * Fill the FieldSet with mapfile data. If invalid, set the FieldSet to null.
     **/
    public MapFile(String mapkey, Params params) throws KeyException {
	try {
	    ReadInputStream in = get(mapkey, params);
	    if (!(in.readTo('\n','\r')).equals("Mapfile")) throw new Exception();
	    FieldSet fsmeta=new FieldSet();
	    if (!(fsmeta.parseFields(in, '\n', '\r', '=', (char) 0)).equals("End")) throw new Exception();
	    fs.parseFields(in, '\n', '\r', '=', (char) 0);
	    if (fsmeta.get("default") != null) {
		String def = fs.get(fsmeta.get("default"));
                if (def != null) fs.put("", def);
	    }
	}
	catch (Exception e) {
	    fs = null;
	    e.printStackTrace();
	    throw new KeyException("Couldn't read MSK Mapfile: " + mapkey);
	}
    }
    
    /**
     * Look up the key for given filename. Return null if invalid mapfile or key not found.
     **/
    public String lookup(String filename) {
	atime = new Date().getTime();
	if (fs == null) return null;
	return (String)fs.get(filename);
    }

    private ReadInputStream get(String mapkey, Params params) throws Exception {
	Bucket b = new FileBucket();
	getSC(params).fillBuckets(mapkey, new FileBucket(), b, true);
	return new ReadInputStream(b.getInputStream());
    }

    // Defer construction of SimplifiedClient until we know what the
    // params should be. 
    // REDFLAG: What if the params change? 
    private final synchronized SimplifiedClient getSC(Params params) {
 	if (sc == null) {
 	    sc = new SimplifiedClient(params);
 	}
 	return sc;
    }
    
    private static SimplifiedClient sc = null;
}
 

