package Freenet.search;

public class OrOperator extends FuzzyOperator
{
    public OrOperator()
    {
	children = new FuzzyOperator[2];
    }

    public float score(String s) throws FuzzyOperatorException
    {
	if ((children[0] == null) || (children[1] == null))
	    {
		throw new FuzzyOperatorException("Children not intialized");
	    }

	float s1 = children[0].score(s);
	float s2 = children[1].score(s);
	return (s1 < s2 ? s2 : s1);
    }

    public String toString()
    {
	return "Or("+children[0].toString()+", "+children[1].toString()+")";
    }
}
