
from struct import pack, unpack

from string import split

from curses import beep

from gennylib import broadcast, get_from

# The chat service
GENNY_CHAT = 6667		# Chatting
SAY = 0				# Normal messages
ACT = 1				# emote or /me
ERROR = 255
NUMERICS = SAY, ACT, ERROR

def handle_command_nick(config, arguments):
	if not arguments:
		print "What nickname do you want?"
	else:
		config['nick'] = arguments
		if config['loglevel'] > 0:
			print "Nick set to %s" % config['nick']
	return

def handle_command_say(config, connections, identifiers, arguments):
	if not arguments:
		print "usage:  s stuff being said"
	else:
		payload = pack('B', SAY) + "%s:%s" % (config['nick'], arguments)
		broadcast(config, connections, identifiers, GENNY_CHAT, payload)
		print "<%s> %s" % (config['nick'], arguments)
	return

def handle_command_act(config, connections, identifiers, arguments):
	if not arguments:
		print "usage:  me stuff being done"
	else:
		payload = pack('B', ACT) + "%s:%s" % (config['nick'], arguments)
		broadcast(config, connections, identifiers, GENNY_CHAT, payload)
                print "* %s %s" % (config['nick'], arguments)
        return

def handle_command_msgbeep(config, arguments):
	if arguments == 'on':
		config['msgbeep'] = 1
		print "Messages will cause beeps."
	elif arguments == 'off':
		config['msgbeep'] = 0
		print "Messages will not cause beeps."
	else:
		print "usage:  msgbeep on|off"
	return

def handle_genny_chat(config, identifiers, r_packet):
        if len(r_packet) < 13:
                if config['loglevel'] > 1:
                        print "Chat packet too small %s: " % conn + \
                                `r_packet`
                payload = pack('B', ERROR) + "Packet was too small."
                respond(config, identifiers, r_packet[:12], GENNY_CHAT, payload)
                return
        numeric = unpack('B', r_packet[12])[0]
	if numeric == SAY:
		if config['loglevel'] > 0:
			if config['msgbeep']:
				beep()
			nick, message = split(r_packet[13:], ':', 1)
			if config['hexbit']:
				print "%08X<%s> %s" % (get_from(r_packet), \
					nick, message)
			else:
				print "<%s> %s" % (nick, message)
	elif numeric == ACT:
		if config['loglevel'] > 0:
			if config['msgbeep']:
				beep()
			nick, message = split(r_packet[13:], ':', 1)
			if config['hexbit']:
				print "%08X* %s %s" % (get_from(r_packet), \
					nick, message)
			else:
				print "* %s %s" % (nick, message)
	return

