
from time import time

from string import split, join

from socket import gethostbyname, error
socket_error = error ; del error

from random import randint

from struct import unpack, pack

# Possible connection flags
CLOSE = 'close'
ICONN = 'initiate connection'
WCONN = 'wait for connection'
SHAND = 'send handshake'
SWELC = 'send welcome'
RHAND = 'receive handshake'
RWELC = 'receive welcome'
GENNY = 'handle genny packet'

PORT = 11105                            # Our port.

class genny_conn:
	def __init__(self, sock, addr):
		# FIXME:  A foo should be sent right after connection.
		self.bar_time = int(time())
		self.last_foo = None
		self.flag = CLOSE
		self.sock = sock
		self.addr = addr
		self.last_bar = None
		self.repr = "%s:%s" % addr
	def __repr__(self):
		return self.repr
	def send(self, s_packet):
	        sent = 0
	        while not sent:
        	        try:
                	        sent = self.sock.sendto(s_packet, self.addr)
	                except socket_error, (errno, strerror):
        	                # Connection refused is ignored.
                	        if errno != 111:
                        	        raise
        	return sent

def broadcast(config, connections, identifiers, service, payload):
	cid = config['nid']
	sid = 0
	bid = config['bid']
	ttl = 7
	s_packet = pack('llBBH', cid, sid, bid, ttl, service) + payload
	identifiers.client[cid] = None
	identifiers.broadcast[(cid, bid)] = int(time())
	for conn in connections:
		if conn.flag == GENNY:
			conn.send(s_packet)
			if config['loglevel'] > 3:
				print "Broadcasted: %s:%s %s" % (conn.addr[0], \
					conn.addr[1], `s_packet`)
	# Cycle the BID.
        if config['bid'] == 255:
                config['bid'] = 0
        else:
                config['bid'] = config['bid'] + 1
	return

def rebroadcast(config, connections, r_conn, r_packet):
	ttl = unpack('B', r_packet[9])[0]
	if ttl:
		s_packet = r_packet[0:9] + pack('B', ttl-1) + r_packet[10:]
		for s_conn in connections:
			if s_conn.flag == GENNY and s_conn is not r_conn:
				s_conn.send(s_packet)
				if config['loglevel'] > 3:
					print "Rebroadcasted %s: %s" % \
						(s_conn, `s_packet`)
	return


def respond(config, identifiers, routing_header, service, payload):
	if ord(routing_header[9]) == 255:
		# We are responding to a Reply.  Therefore we must send a
		# Rereply.  Rereplies are routed to the SID.
		cid = config['nid']
		identifiers.client[cid] = None
		sid = unpack('l', routing_header[4:8])[0]
		s_conn = identifiers.server[sid]
		ttl = 254
	else:
		# We are responding to a Rereply or a Broadcast.  Therefore we
		# must send a Reply.  Replies are routed to the CID.
		cid = unpack('l', routing_header[0:4])[0]
		s_conn = identifiers.client[cid]
		sid = config['nid']
		identifiers.server[sid] = None
		ttl = 255
	s_packet = pack('llBBH', cid, sid, 0, ttl, service) + payload
	s_conn.send(s_packet)
        if config['loglevel'] > 3:
                print "Responded %s: " % s_conn + `s_packet`
	return
	
def for_me(identifiers, r_packet):
	if ord(r_packet[9]) == 255:
		if identifiers.client[unpack('l', r_packet[0:4])[0]] == None:
			return 1
	elif ord(r_packet[9]) == 254:
		if identifiers.server[unpack('l', r_packet[4:8])[0]] == None:
			return 1
	# No broadcasts are "for" anyone.
	return 0

#def from_me(identifiers, r_packet):
#	if ord(r_packet[9]) <= 7 or ord(r_packet[9]) == 254:
#		if identifiers.client[unpack('l', r_packet[0:4])[0]] == None:
#			return 1
#	if ord(r_packet[9]) == 255:
#		if identifiers.server[unpack('l', r_packet[4:8])[0]] == None:
#			return 1
#	return 0

#def raw_recv(s, bufsize):
#	try:
#		r_packet, raddr = s.recvfrom(bufsize)
#	except SocketError, (errno, strerror):
#		# Connection refused is ignored.
#		if errno != 111:
#			raise
#	return r_packet, raddr

def raw_send(s, s_packet, s_addr):
	sent = 0
	while not sent:
		try:
			sent = s.sendto(s_packet, s_addr)
		except socket_error, (errno, strerror):
			# Connection refused is ignored.
			if errno != ECONNREFUSED:
				print "s_packet -> %s, s_addr -> %s" % \
					(`s_packet`, s_addr)
				raise
	return sent

def get_random_bytes(size):
        foo_list = []
        for i in range(size):
                foo_list.append(chr(randint(0, 255)))
        return join(foo_list, '')

def hostify(hosttmp):
        hosttmp = split(hosttmp, ':', 1)
        if len(hosttmp) == 2:
                host = gethostbyname(hosttmp[0]), int(hosttmp[1])
        else:
                host = gethostbyname(hosttmp[0]), PORT
        return host

def hostorip2rawip(ipaddy):
	rawip = join(map(lambda x:chr(int(x)), \
		split(gethostbyname(ipaddy), '.')), '')
	return rawip

def rawip2ip(rawip):
	ip = join(map(lambda x:str(ord(x)), rawip), '.')
	return ip

def get_from(routing_header):
	"""get_from(routing_header) -> int

Takes the routing header of a packet and returns the node identifier of the
sending servant as an integer."""
	if ord(routing_header[9]) == 255:
		nid = routing_header[4:8]
	else:
		nid = routing_header[0:4]
	return unpack('l', nid)[0]

