#ifndef __UPLOAD_H
#define __UPLOAD_H

#include <sys/mman.h>
#include <dirent.h>

#include "parse_ext.h"

#include "md5.h"

#ifndef MAP_FAILED
#define MAP_FAILED ((void *) -1)
#endif /* MAP_FAILED */

#define PACK(x) ((x[0] << 24) | (x[1] << 16) | (x[2] << 8) | (x[3]))

#define SUBMIT_LIST  0x01
#define UPDATE_LIST  0x02
#define BUILD_LIST   0x04

/*struct _MP3Header {
   int index, id, layer, protection_bit, bitrate_index, frequency;
   int padding_bit, private_bit, mode, mode_ext, copyright, original;
   int emphasis;
};

struct _MP3Stats {
   char *filename;
   char *checksum;
   unsigned long filesize;
   unsigned short frequency;
   unsigned short bitrate;
   time_t time;
   time_t mtime;
};

struct _ShareFileEntry {
   time_t mtime;
   char *file;
};*/

/* prototypes */
void register_formats();
void shared_free(STab *stab);
void share_addpath(GtkWidget *w, void *data);
void share_rempath(GtkWidget *w, void *data);
void share_showpath(GtkWidget *w, int row, int col, GdkEvent *ev, void *data);
char *share_buildpathstr(GtkWidget *clist);
void fill_share_paths(GtkWidget *clist);
ShareData *get_share_data(int source, char **str);
void build_pipe_read(gpointer data, int source, GdkInputCondition condition);
void pipe_finish(int fd);
void setup_build_dlg(STab *stab, char *root, int flags);
void remove_slash(char *s);
FILE *open_shared(char *flags);
int parse_shared_entry(char *s, ShareData *shr);
char *path_get_file(char *file);
char *path_get_dir(char *file);
GList *share_find(STab *stab, char *dir);
void share_add(STab *stab, ShareData *shr);
void share_remove(STab *stab, ShareData *shr);
ShareData *find_share_mtime(STab *stab, char *path);
void share_submit(STab *stab);
void build_shares(STab *stab);
int share_cmp(FileEntry *fe1, FileEntry *fe2);
void sort_shares(STab *stab);
int sanitize_path(char **s);
int shared_list_handle(STab *stab, char *root, int flags);
/* !prototypes */

#endif /* __UPLOAD_H */
