# Note that this is NOT a relocatable package
# defaults for redhat
%define prefix		/usr
%define sysconfdir	/etc
%define  RELEASE 1
%define  rel     %{?CUSTOM_RELEASE} %{!?CUSTOM_RELEASE:%RELEASE}

Summary: Gnapster is a powerful napster client written for GTK+ and GNOME
Name: gnapster
Version: 1.5.0
Release: %rel
Copyright: GPL
Group: Applications/Communications
URL: http://jasta.gotlinux.org/gnapster.html
Source: http://jasta.gotlinux.org/files/%{name}-%{version}.tar.gz
Requires: gnome-libs >= 1.0.0
Requires: ORBit >= 0.4.0
Requires: gtk+ >= 1.2.0
Packager: jasta <jasta@gotlinux.org>
BuildRoot: /var/tmp/%{name}-%{version}-root

%description
Gnapster is a small but powerful client for the napster protocol, 
written for GTK and GNOME. If you would like to contribute, 
please contact jasta <jasta@gotlinux.org>.

%prep
%setup -q

# seems as if xss support is broken on alpha :-(
%ifarch alpha
  ARCH_FLAGS="--host=alpha-redhat-linux --without-xss"
%endif

if [ ! -f configure ]; then
  CFLAGS="$RPM_OPT_FLAGS" ./autogen.sh $ARCH_FLAGS --prefix=%{prefix} --sysconfdir=%{sysconfdir}
else
  CFLAGS="$RPM_OPT_FLAGS" ./configure $ARCH_FLAGS --prefix=%{prefix} --sysconfdir=%{sysconfdir}
fi

%build

if [ "$SMP" != "" ]; then
  make -j$SMP "MAKE=make -j$SMP"
else
  make
fi

%install
make prefix=$RPM_BUILD_ROOT%{prefix} sysconfdir=$RPM_BUILD_ROOT%{sysconfdir}  install-strip

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog INSTALL NEWS README TODO
%{prefix}/bin/gnapster
%{prefix}/share/pixmaps/*
%{prefix}/share/gnapster/themes/*

###################################################################
%changelog
* Fri Jan 14 2000 Joaquim Fellmann <joaquim@hrnet.fr>
- made the gnome archive from the standalone sources
