/*
 *  Gnubile - Gnutella software for Unix
 *  Copyright (C) 2000  Spencer Kimball and Gene Kan
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "http.h"

char* http_encode_dup(const char* _s) {
	char* encode_buf;
	char* p;

	for (encode_buf = p = (char*) malloc(strlen(_s) * 3 + 1); *_s; _s++) {
		if (isalnum(*_s))
			*p++ = *_s;
		else if (*_s == ' ')
			*p++ = '+';
		else {
			sprintf(p, "%%%X", *_s);
			p += 3;
		}
	}

	*p = '\0';

	return encode_buf;
}

char* http_decode_dup(const char* _s) {
	char* encode_buf;
	char* p;
	char xbuf[3];

	for (encode_buf = p = (char*) malloc(strlen(_s) + 1); *_s; p++) {
		if (*_s == '%') {
			xbuf[0] = _s[1];
			xbuf[1] = _s[2];
			xbuf[2] = '\0';
			*p = strtoul(xbuf, NULL, 16);
			_s += 3;
		}
		else if (*_s == '+') {
			*p = ' ';
			_s++;
		}
		else {
			*p = *_s;
			_s++;
		}
	}

	*p = '\0';

	return encode_buf;
}
