/*
 *  Gnubile - Gnutella software for Unix
 *  Copyright (C) 2000  Spencer Kimball and Gene Kan
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef STREAM_STD_H

#define STREAM_STD_H

void stream_openlog (const char* _ident);
void stream_closelog (void);
void stream_log (const char* _s, ...);

#define stream_err(msg) stream_log("%s:%d: %s: '%s': %s (%d)", __FILE__, __LINE__, __FUNCTION__, msg, strerror(errno), errno)
#define stream_msg(msg) stream_log("%s:%d: %s: '%s'", __FILE__, __LINE__, __FUNCTION__, msg)

#define MAX_MSGLEN 4096

#endif
