/*
 *  Gnubile - Gnutella software for Unix
 *  Copyright (C) 2000  Spencer Kimball and Gene Kan
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __DOWNLOAD_H__
#define __DOWNLOAD_H__

/*
 * Interface to the download functionality
 */

#include "search.h"

typedef enum
{
  DOWNLOAD_CONNECTING,
  DOWNLOAD_ACTIVE,
  DOWNLOAD_COMPLETE,
  DOWNLOAD_ABORTED,
  DOWNLOAD_ERROR
} DownloadStatus;

typedef struct _DownloadFile
{
  gchar          *filename;
  gint32          size;
  gint32          read;
  gint32          link_speed;
  DownloadStatus  status;
} DownloadFile;

void download_register (SearchResult   *result);
void download_clear    (DownloadFile   *dfile);
void download_update   (DownloadFile   *dfile,
			DownloadStatus  new_status);
void download_abort    (DownloadFile   *dfile);


#endif  /* __DOWNLOAD_H__  */
