#include <sys/types.h>
#include <netinet/in.h>
#include <stdio.h>

#include "ip.h"

char* ip2str (u_int32_t _ip) {
	static char s[40];

	sprintf(s, "%d.%d.%d.%d",
			(_ip & 0xff000000) >> 24,
			(_ip & 0x00ff0000) >> 16,
			(_ip & 0x0000ff00) >>  8,
			(_ip & 0x000000ff) >>  0);

	return s;
}

int ipisroutable (u_int32_t _ip) {
	union {
		unsigned char c[4];
		u_int32_t     i;
	} ip;

	ip.i = htonl(_ip);

	return (!(ip.c[0] == 0 || /* rumoured to be unrouted. */
		      ip.c[0] == 10 || /* unroutable in RFC 1918 */
			  (ip.c[0] >= 64 && ip.c[0] <= 127) || /* reserved in RFC 1466 */
		      (ip.c[0] == 172 && ip.c[1] >= 16 && ip.c[1] <= 31) || /* unroutable in RFC 1918 */
		      (ip.c[0] == 192 && ip.c[1] == 168) || /* unroutable in RFC 1918 */
		      ip.c[0] >= 224)); /* reserved for multicast */
}
