/*
 *  Gnubile - Gnutella software for Unix
 *  Copyright (C) 2000  Spencer Kimball and Gene Kan
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * Interface to the monitor functionality
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>
#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"
#include "globals.h"

#define MAX_CACHE_RESULTS 100

/*
 *  This function is called by the server to log a message
 *   to the monitor (ie. as each new search request is received
 */
void monitor_append (gchar *message)
{
  gchar *text[2];

  GtkCList *clist = GTK_CLIST (lookup_widget (app, "monitorlist"));

  /*  Insert into list  */
  text[0] = g_strdup(message);
  text[1] = g_strdup("1");
  gtk_clist_prepend (clist, text);

  /*  Check the number of listbox rows  */
  if (clist->rows > MAX_CACHE_RESULTS)
	{
	  /*  Remove the last row  */
	  gtk_clist_remove (clist, clist->rows - 1);
    }
}
