/*
 *  Gnubile - Gnutella software for Unix
 *  Copyright (C) 2000  Spencer Kimball and Gene Kan
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __SEARCH_H__
#define __SEARCH_H__

/*
 * Interface to the search functionality
 */

#include <sys/types.h>
#include "uuid.h"

typedef struct _SearchResult
{
  gchar  *filename;
  gint32  size;
  gchar  *server;
  gint32  port;
  gint32  link_speed;
  gint32  index;
  uuid    search_id;
} SearchResult;

void search_search   (gchar        *search_str);
void search_clear    (void);
void search_result   (SearchResult *result);
void search_download (SearchResult *result);

#endif  /* __SEARCH_H__  */
