/*
 *  Gnubile - Gnutella software for Unix
 *  Copyright (C) 2000  Spencer Kimball and Gene Kan
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef STREAM_INET_H

#define STREAM_INET_H

/*

#include <sys/types.h>
#include <sys/socket.h>

*/

#define in2ascii(saddr_in) inet_ntoa(saddr_in.sin_addr)

/*

   This stuff is designed to run with stream_scheduler.

   This is a little spaghetti.  Could be fixed with another level of
   indirection and *UGH* an extra callback layer.

*/

/* fdx is the index at which the server/client socket is held in the
   stream_sched. */

typedef struct _stream_serv {
	int s;
	u_int32_t ourip;
	u_int16_t ourport;

	u_int32_t theirip;
	u_int16_t theirport;

	void* privdata;
} stream_host;

stream_host* stream_serv_new
(u_int16_t _port, int _backlog,  void* _privdata, stream_sched_cb _cb);
stream_host* stream_serv_accept (int _fd, stream_sched_cb _cb, void* _privdata);
void stream_host_close (stream_host* _host);

stream_host* stream_cli_new
(char* _name_or_ip, u_int16_t _port, void* _privdata, stream_sched_cb _cb);

#endif /* STREAM_INET_H */
