/*
 *  Gnubile - Gnutella software for Unix
 *  Copyright (C) 2000  Spencer Kimball and Gene Kan
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef STREAM_SCHED_H

#define STREAM_SCHED_H

/*

#include "stream_config.h"
#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>

*/

#ifndef STREAM_CONFIG_H
#error Must include stream_config.h before anything else!
#endif

#define STREAMIN	0x1
#define STREAMOUT	0x2
/*#define STREAMOOB	0x4*/
#define STREAMHUP	0x8
#define STREAMCONNECT	0x10
#define STREAMKILL  0x20
#define STREAMCALL  0x40

typedef struct _stream_sched stream_sched;

typedef void (*stream_sched_cb)
(int _fd, short _events,
 char* _rbuf, int _rbytes,
 char* _wbuf, int _wbytes,
 void* _privdata);

struct _stream_sched {
	int nfds;	/* Number of file descriptors in this scheduler.
			   Just for book keeping. */

	fd_set r, w;
	int maxfd;
};

void stream_sched_init (void);
int stream_sched_run (int _to_ms);
int stream_sched_add_fd
(int _fd, stream_sched_cb _cb, void* _privdata);
int stream_sched_add_listen_fd
(int _fd, stream_sched_cb _cb, void* _privdata);
int stream_sched_add_connect_fd
(int _fd, stream_sched_cb _cb, void* _privdata);
void stream_sched_del_fd (int _fd);
void stream_sched_set_fd_ev (int _fd, short _events);
short stream_sched_get_fd_ev (int _fd);
void stream_sched_add_fd_ev (int _fd, short _events);
void stream_sched_sub_fd_ev (int _fd, short _events);
void stream_sched_post_read
(int _fd, char* _buf, int _len);
void stream_sched_consume
(int _fd, int _n);
void stream_sched_post_write
(int _fd, char* _buf, int _len);
void stream_sched_kill (int _fd);
void stream_sched_call (int _fd);

#endif /* STREAM_SCHED_H */
