/*
 *  Gnubile - Gnutella software for Unix
 *  Copyright (C) 2000  Spencer Kimball and Gene Kan
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* * * * * * * * * * * * * * * * * * * *
 * textutils.h
 *
 * Prototypes for text manipulation functions.
 *
 * 7-95 Version 1
 * * * * * * * * * * * * * * * * * * * */

#ifndef __TEXTUTILS_H__

#define __TEXTUTILS_H__

#define LEADING 1			/* defines for stripspaces. */
#define TRAILING 2

char *chop (char *string);
char *cut (char *string);
char *stripspaces (char *s, int mode);
u_int32_t hashpjw (const void* s, int len);
char* strjoindup (const char* _joinsep, int _n, ...);
int sscanbstream (u_int8_t* _stream, int _streamlen, const char* _format, ...);
int vsprintbstream (u_int8_t* _stream, const char* _format, va_list _ap);
int sprintbstream (u_int8_t* _stream, const char* _format, ...);
int formatsize (const char* _format);

#endif
