/* Josh Pieper, (c) 2000 */

/* This file is distributed under the GPL, see file COPYING for details */

#ifndef CLI_OUTPUT_H
#define CLI_OUTPUT_H

#ifdef __cplusplus
extern "C" {
#endif

int cli_output_init();
int cli_output_reset();

/* give this function the number of lines after this one that
 * shouldn't be separated over a page break */
int cli_output_line(int,char *);

char wait_key_callback(void (*a)(void));
void raw_mode(int);

extern char *output_bold_on;
extern char *output_special_off;

#define cli_output_text cli_output_line

#ifdef HAVE_TERMCAP_H
#include <termcap.h>
#endif

#ifdef HAVE_LIBTERMCAP
#  define tputs_x(x) tputs(x,1,putchar)
#else
#  define tputs_x(x)
#endif

#ifdef __cplusplus
}
#endif

#endif
