/* Josh Pieper, (c) 2000 */

/* This file is distributed under the GPL, see file COPYING for details. */

#ifndef GNUT_QUEUE_H
#define GNUT_QUEUE_H

#include "lib.h"
#include "list.h"

typedef struct _Gnut_Queue Gnut_Queue;

struct _Gnut_Queue {
  Gnut_List *head;
  Gnut_List *tail;
  uint32 size;
};

#ifdef __cplusplus
extern "C" {
#endif

  void fre_gq(Gnut_Queue **x, int bugnum);

  Gnut_Queue * gnut_queue_new(int tracking_number);
  void gnut_queue_fre(Gnut_Queue *);
  void gnut_queue_insert(Gnut_Queue *, void *, int tracking_number);
  void * gnut_queue_remove(Gnut_Queue *);
  void gnut_queue_delete(Gnut_Queue *, void *);

  Gnut_List * gnut_queue_list(Gnut_Queue *);

#ifdef __cplusplus
}
#endif

#endif
