/* Josh Pieper, (c) 2000 */

/* This file is distributed under the GPL, see file COPYING for details */

#ifndef GNUT_TRANSFER_H
#define GNUT_TRANSFER_H

#include <pthread.h>
#include <time.h>
#include "lib.h"

typedef struct _gnut_transfer gnut_transfer;

struct _gnut_transfer {
  int sock;
  
  uchar ip[4];
  uint16 port;
  
  int fsock;
  char *fname;
  
  /* indicates whether an upload, or download, or push */
  int type;
  
  uint32 bytes;
  int total;
  
  uint32 rate_bytes;
  time_t rate_incr_time;

  uint32 rate_limit;
  
  /* states are the same as for connections */
  int state;
  int substate;
  
  /* for ui purposes... */
  int index;

  pthread_t tid;
};

#ifdef __cplusplus
extern "C" {
#endif

  void fre_gt(gnut_transfer **x, int bugnum);
  gnut_transfer * gnut_transfer_new();
  int gnut_transfer_delete(gnut_transfer *gt);

  void decay_rate(gnut_transfer *gt);
  int gnut_transfer_loop(gnut_transfer *gt, int overlap, char *overlap_buf,
			 int dest_cache);

  int gnut_transfer_enumerate( int(*a)(gnut_transfer *));

  int gnut_transfer_num();

#ifdef __cplusplus
}
#endif

#endif
