/*
 * Copyright (c) 2001 Sun Microsystems, Inc.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *       Sun Microsystems, Inc. for Project JXTA."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "Sun", "Sun Microsystems, Inc.", "JXTA" and "Project JXTA" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact Project JXTA at http://www.jxta.org.
 *
 * 5. Products derived from this software may not be called "JXTA",
 *    nor may "JXTA" appear in their name, without prior written
 *    permission of Sun.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL SUN MICROSYSTEMS OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of Project JXTA.  For more
 * information on Project JXTA, please see
 * <http://www.jxta.org/>.
 *
 * This license is based on the BSD license adopted by the Apache Foundation.
 *
 * $Id: CommonDialog.java,v 1.4 2001/05/25 17:51:25 kuldeep Exp $
 */

package net.jxta.instantp2p.desktop;

import java.awt.*;
import java.awt.event.*;

public class CommonDialog extends Dialog implements ActionListener {

    Button closeButton;
    static TextArea  textPanel;
    Frame frame;

    public CommonDialog ( Frame frame ) {
        super ( frame, true );
	this.frame = frame;
	setSize ( 400, 300 );

	setTitle ( "IP2P" );
	setLayout ( new BorderLayout ());
	setBackground ( Color.lightGray );
	setForeground ( Color.black );

	//	setResizable ( false );
	textPanel = new TextArea ("", 10, 40, 
				  TextArea.SCROLLBARS_NONE  );
	textPanel.setEditable ( false );
	add ( textPanel, "Center");

        Panel closePanel = new Panel ();
        closePanel.setLayout ( new FlowLayout ());
	closeButton = new Button ( "OK" );
	closeButton.addActionListener ( this );
        closePanel.add ( closeButton );
	add ( closePanel, "South" );	
	pack ();
    }

    public void setText ( String [] strs ) {
        
        textPanel.setText ("");
        for ( int i = 0; i < strs.length; i++ ) {
            textPanel.append ( strs[i] + "\n" );
	}
	setVisible ( true );

	Dimension pd = frame.getSize();
	Dimension d = getSize();
	Point p = frame.getLocationOnScreen();
	int x = p.x + (pd.width-d.width)/2;
	int y = p.y + (pd.height-d.height)/2;
	setLocation(new Point(x, y));
    }

    public void actionPerformed ( ActionEvent evt ) {
        setVisible ( false );
    }
}
