// Jason Rohrer
// ClientSettings.java


/**
*
*	Container class for client settings.
*
*	Created 7-4-2000
*	Mods:
*		Jason Rohrer	9-29-2000	Added window position and location
*									to list of settings.
*		Jason Rohrer	9-30-2000	Changed from storing a File to storing
*									a FileDirectoryPath.  Added a constructor
*									to facilitate default initialization of 
*									the FileDirectoryPath.
*/


package konspire.client;

import konspire.common.FileDirectoryPath;

import java.io.File;
import java.io.Serializable;

import java.awt.Dimension;
import java.awt.Point;

/**
 * Container class for client settings.
 *
 *
 * @author Jason Rohrer
 */
public class ClientSettings implements Serializable {
	
	public FileDirectoryPath mDirectoryPath;
	
	//public File mFilesDirectory = new File( "files" );
	
	public Dimension mMainWindowSize = new Dimension( 500, 500 );
	public Point mMainWindowLocation = new Point( 50, 50 );
	
	public Dimension mTransferWindowSize = new Dimension( 400, 400 );
	public Point mTransferWindowLocation = new Point( 200, 200 );
	
	/**
	 * Constructs a <code>ClientSettings</code>.  Carries out
	 * all necessary default initialization of members.
	 */
	public ClientSettings() {
		mDirectoryPath = new FileDirectoryPath();
		mDirectoryPath.setDownloadDirectory( new File( "files" ) );
		}
	
	}
