// Jason Rohrer
// EtchedTitledJPanel.java

/**
*
*	GUI component consisting of a JPanel w/ an etched, titled border
*
*	Created 5-11-2000
*	Mods:
*/

package konspire.client;


import javax.swing.JPanel;

import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;


/**
 * JPanel with an etched, titled border.
 *
 * @author Jason Rohrer
 */
public class EtchedTitledJPanel extends JPanel {
	
	private TitledBorder tBorder;
	
	/**
	 * Constructs a panel with no title
	 */
	public EtchedTitledJPanel( ) {
		setup( "" );
		}
	
	/**
	 * Constructs a panel with a title
	 *
	 * @param title title of panel
	 */
	public EtchedTitledJPanel( String title ) {
		setup( title );
		}
	
	
	/**
	 * Sets the title of this panel
	 *
	 * @param newTitle new title for this panel 
	 */
	public void setTitle( String newTitle ) {
		tBorder.setTitle( newTitle );
		}
	
	
	/**
	 * Sets up panel with title.  Shared by the various constructors.
	 *
	 * @param title the title to place on the border of the panel
	 */
	private void setup( String title ) {
		tBorder = new TitledBorder( new EtchedBorder(), title );
		setBorder( tBorder );
		}
	
	}