// Jason Rohrer
// LabeledFieldJLabel.java

/**
*
*	JLabel that displays a value preceeded or followed by a fixed label 
*
*	Created 6-1-2000
*	Mods:
*/

package konspire.client;

import javax.swing.JLabel;

/**
 * JLabel that displays a value preceeded or followed by a fixed label.
 * All spacing between label and value must be handled by caller. 
 *
 * @author Jason Rohrer
 */
public class LabeledFieldJLabel extends JLabel {
	
	private String label;
	private String value;
	private boolean labelBefore;
	
	/**
	 * Constructs a LabeledFieldJLabel.
	 *
	 * @param labl fixed label string
	 * @param val value string
	 * @param before true iff label string comes before value string
	 */
	public LabeledFieldJLabel( String labl, String val, boolean before ) {
		label = labl;
		value = val;
		labelBefore = before;	
		setValue( val );
		}
		
	/**
	 * Sets the value string of this label.
	 *
	 * @param val value string
	 */
	public void setValue( String val ) {
		value = val;
		
		if( labelBefore ) {
			setText( label + value );
			}
		else {
			setText( value + label );
			}
		}
	
	/**
	 * Sets the label string of this label.
	 *
	 * @param labl fixed label string
	 */
	public void setLabel( String labl ) {
		label = labl;
		setValue( value );
		}
	}
