// Jason Rohrer
// ServerListPanel.java

/**
*
*	Bordered panel for server list
*
*	Created 5-11-2000
*	Mods:
*/

package konspire.client;

import konspire.common.Host;
import konspire.common.ServerList;
import konspire.common.Vector;

import javax.swing.*;

import java.awt.FlowLayout;

/**
 * Panel that displays the current live server list.
 *
 * @author Jason Rohrer
 */
public class ServerListPanel extends EtchedTitledJPanel {


	JList serverList;
	JScrollPane serverListScrollPane;
	
	String title = "server list";
	
	/**
	 * Constructs a <code>ServerListPanel</code>
	 */
	public ServerListPanel() {
		
		setTitle( title );
		
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		
		serverList = new JList();
		
		serverListScrollPane = new JScrollPane();
 		serverListScrollPane.getViewport().setView( serverList );	
		
		add( serverListScrollPane );
		}
	
	/**
	 * Sets the <code>ServerList</code> to be displayed by specifying
	 * a server list message.
	 *
	 * @param sList the list messge to be displayed
	 */
	public void setServerList( ServerList sList ) {
		serverList.setListData( sList.getHostVector() );
		}
	
	/**
	 * Sets the <code>ServerList</code> to be displayed by specifying
	 * a vector of <code>Host</code>s.
	 *
	 * @param sList the vector of hosts to be displayed
	 */
	public void setServerList( Vector hostVector ) {
		serverList.setListData( hostVector );
		}
		
	}