package konspire.client;

import java.awt.*;

/**
 * Class containing static utility methods for manipulating windows
 *
 * @author Jason Rohrer
 */
public class WindowUtils {

    /**
     * Center a window on the screen
     *
     * @param inWindow the window to center
     */
    public static void centerWindow( Window inWindow ) {
        Toolkit kit = inWindow.getToolkit();
        Dimension screenSize = kit.getScreenSize();
        int screenWidth = screenSize.width;
        int screenHeight = screenSize.height;
        Dimension windowSize = inWindow.getSize();
        int windowWidth = windowSize.width;
        int windowHeight = windowSize.height;

        int upperLeftX = (screenWidth - windowWidth)/2;
        int upperLeftY = (screenHeight - windowHeight)/2;

        inWindow.setLocation(upperLeftX, upperLeftY);
    	}
	}