// Jason Rohrer
// ClientDisconnect.java

/**
*
*	Message propagated by a server when one of its clients disconnects.
*
*	Created 5-4-2000
*	Mods:
*		Jason Rohrer	8-20-2000	Added a toString() method.
*/

package konspire.common;


/**
 * Message propagated by a server when one of its <code>Client</code>s disconnects.
 *
 * @author Jason Rohrer
 */
public class ClientDisconnect implements Message {

	private Host clientAddress;
	
	/**
	 * Constructs a <code>ClientDisconnect</code> message.
	 *
	 * @param clientAddr address of <code>Client</code> that is down
	 */
	public ClientDisconnect( Host clientAddr ) {
		clientAddress = clientAddr;
		}
	
	/**
	 * Gets the address of the dead <code>Client</code>
	 *
	 * @return the address of the dead <code>Client</code>
	 */
	public Host getClientAddress() {
		return clientAddress;
		}


	// overrides the Object toString() method
	public String toString() {
		return "ClientDisconnect: " + clientAddress;
		}	
	
	}
