// Jason Rohrer
// ConnectResponse.java

/**
*
*	Message from server granting or denying client a connection
*
*	Created 5-4-2000
*	Mods:
*/


package konspire.common;

/**
 * Message sent from a <code>Server</code> to a <code>Client</code>
 * granting or denying the <code>Client</code> a dedicated socket connection.
 *
 * @author Jason Rohrer
 */
public class ConnectResponse extends ToClientMessage {


	private boolean accepted;
	
	
	/**
	 * Constructs a <code>ConnectResponse</code>.
	 *
	 * @param accept true iff <code>Client</code> connection is accepted
	 */
	public ConnectResponse( boolean accept ) {
		accepted = accept;
		}
	
	/**
	 * Gets whether <code>Client</code> connection is accepted
	 *
	 * @return true iff <code>Client</code> connection is accepted
	 */
	public boolean isAccepted() {
		return accepted;
		}	
	
	}