// Jason Rohrer
// ErrorHandler.java

/**
*
*	Class that handles any throwables.
*
*	Created 8-21-2000
*	Mods:
*/

package konspire.common;

import konspire.common.log.AppLog;

/**
 * Framework for handing any <code>Throwable</code> errors and exceptions.
 * <p>
 * Note that in the current implementaion, stack traces are printed
 * to the log for each error handled.
 *
 * @author Jason Rohrer
 */
public class ErrorHandler {
	
	
	/**
	 * Handles a general <code>Throwable</code>.
	 *
	 * @param inThrowable the error to handle
	 */
	public static void report( Throwable inThrowable ) {
		StringPrintWriter stackTraceWriter = new StringPrintWriter();
		
		inThrowable.printStackTrace( stackTraceWriter );
		
		String stackTrace = stackTraceWriter.toString();
		
		if( inThrowable instanceof Error ||
			inThrowable instanceof RuntimeException ) {
			
			AppLog.criticalError( stackTrace );
			}
		else {
			AppLog.error( stackTrace );
			}
		}

	}
