// Jason Rohrer
// UnitsPrefixFormat.java

/**
*
*	Scales values into units of a different order of magnitude.
*
*	E.g., 2000 m would be converted to 2 km.
*
*	Created 7-3-2000
*	Mods:
*/

package konspire.common;

/**
 * Converts values and units to values in units with order of
 * magnitude prefixes.
 *
 */
public interface UnitsPrefixFormat {

	/**
	 * Convert a value and unit to a scaled value and prefixed unit.
	 *
	 * @param inValue the value to convert, in base units
	 * @param inUnits string representing the base units
	 *
	 * @returns String representing scaled value with units
	 */
	public String convertUnitsPrefix( double inValue, String inUnits );
	
	}