package konspire.common.log;

/**
 * This logging mechanism adds today's date to the shared log file name, and also
 * rolls logging over to a new file when dates change (the first new string
 * logged on a new date causes the current log file to close and a new log
 * file to be opened with today's date).
 *
 * @author Todd Lauinger
 * @version $Revision: 1.3 $
 */
public class SharedDatedFileLoggingMechanism extends SharedFileLoggingMechanism {

	// Make the singleton variable be a class instance variable
	// by overriding its definition in this subclass.
	protected static SharedDatedFileLoggingMechanism singleton =
		new SharedDatedFileLoggingMechanism();

	//
	// Class instance accessor which answers the singleton instance of the
	// concrete subclass.
	//
	public static AbstractLoggingMechanism getInstance() {

		return singleton;
	}

    // This is a dated log and needs to have a date appended to the
    // file name and must be rolled over when the current date changes.
    protected boolean isDatedLog() {
        return true;
    }

}

