package konspire.common.log;

/**
 * This logging mechanism logs errors to the System.err output stream.
 * This is the default logging mechanism.  As such, we don't want to cloud
 * it up with notification messages, like those in the file logs.
 *
 * @author Todd Lauinger
 * @version $Revision: 1.3 $
 */
public class StandardErrLoggingMechanism extends AbstractLoggingMechanism {

	protected static StandardErrLoggingMechanism singleton =
		new StandardErrLoggingMechanism();

	//
	// Class instance accessor which answers the singleton instance of the
	// concrete subclass.
	//
	public static AbstractLoggingMechanism getInstance() {

		return singleton;
	}

	protected void notifyLogOpened(Log log) {

		// Override the notification method to do nothing, no need to clutter
		// StdErr with notification messages.
	}

	protected void notifyLogClosed(Log log) {

		// Override the notification method to do nothing, no need to clutter
		// StdErr with notification messages.
	}

	void notifyLoggingLevelChange(Log log, int loggingLevel) {

		// Override the notification method to do nothing, no need to clutter
		// StdErr with notification messages.
	}

}
