package konspire.common.log;

import java.io.*;
import java.util.*;
import java.text.*;

/**
 * This logging mechanism adds today's date to the log file name, and also
 * rolls logging over to a new file when dates change (the first new string
 * logged on a new date causes the current log file to close and a new log
 * file to be opened with today's date).
 *
 * @author Todd Lauinger
 * @version $Revision: 1.3 $
 */

public class UniqueDatedFileLoggingMechanism extends UniqueFileLoggingMechanism {

	// Unique mechanisms require new instances for each log!
	public static AbstractLoggingMechanism getInstance() {

		return new UniqueDatedFileLoggingMechanism();
	}

    // This is a dated log and needs to have a date appended to the
    // file name and must be rolled over when the current date changes.
    protected boolean isDatedLog() {
        return true;
    }

}

