package konspire.common.log;

/**
 * This logging mechanism is the simplest implementation of a file logging
 * mechanism.  It is designed to have one log file per log, with the name
 * of the log as part of the file name.  It doesn't do anything fancy like
 * rolling over to a new file when a date changes, it appends all messages
 * to the same file name if already present.
 *
 * @author Todd Lauinger
 * @version $Revision: 1.3 $
 */
public class UniqueFileLoggingMechanism extends AbstractFileLoggingMechanism {

	// Unique mechanisms require new instances for each log!
	public static AbstractLoggingMechanism getInstance() {

		return new UniqueFileLoggingMechanism();
	}

    // Override the default, this log type is not shared.
    protected boolean isSharedLog() {
        return false;
    }

}

