// Jason Rohrer
// NewServerUp.java

/**
*
*	Message containing information about a new <code>Server</code>
*
*	Created 5-4-2000
*	Mods:
*		Jason Rohrer	8-20-2000	Added a toString() method.
*/

package konspire.server;

import konspire.common.Message;
import konspire.common.Host;

/**
 * Message containing information about a new server.
 *
 * @author Jason Rohrer
 */
public class NewServerUp implements Message {

	protected Host serverAddress;
	
	/**
	 * Constructs a <code>NewServerUp</code> message.
	 *
	 * @param serverAddr address of new <code>Server</code> as determined by the
	 *  new <code>Server</code>. May be incorrect if 
	 *  <code>Server</code> is behind some sort of firewall. 
	 */
	public NewServerUp( Host serverAddr ) {
		serverAddress = serverAddr;
		}
	
	/**
	 * Gets address of new <code>Server</code> as determined by the
	 *  new <code>Server</code>. May be incorrect if 
	 *  <code>Server</code> is behind some sort of firewall. 
	 *
	 * @return the suspected address of new <code>Server</code>
	 */
	public Host getServerAddress() {
		return serverAddress;
		}
	
	// overrides the Object toString() method
	public String toString() {
		return "New server up: " + serverAddress;
		}	
	}
