import sys
import os
# distutils is included with python 1.6 and later, go grab a if you use python 1.5.2.
from distutils.core import setup, Extension

# XXX this hack because the distutils included with python 1.6 accepts
# but doesn't support the define_macros parameter to Extension() seen
# below.  It does support the CFLAGS environment variable.  Getting a
# later version of distutils (presumably the one included with python 2.0?)
# will hopefully make this unnecessary.
if sys.platform == 'win32':
    os.environ['CFLAGS'] = '/DPYTHON_MODULE'
    lib_dirs = [os.path.join(sys.prefix, 'PCbuild')]
else:
    os.environ['CFLAGS'] = '-DPYTHON_MODULE'
    lib_dirs = []

setup ( name = "blockshare",
        version = "1.0",
        author = "Autonomous Zone Industries",
        author_email = "mojonation-devel@lists.sourceforge.net",
        ext_modules = [
            Extension(
                "blockshare",
                ["blocksharemod.c", "../init_params.c", "../make_shares.c", "../rebuild.c", "../share_in.c"],
                include_dirs=["../", os.path.join(sys.prefix, 'PC')],
                library_dirs=lib_dirs,
                define_macros=[('PYTHON_MODULE', None)],  # XXX this doesn't work with the distutils included with 1.6
            )
        ],
      )

