
#include <stdio.h>

#include "share.h"
#include "share_local.h"

// Take a full message block, and create
// a number of shares, then store them
// in the SHARE structure
//

int make_shares(SHARE *s) {

// dereference for clarity, fingers, speed
int cur_share, cur_mpkt, pkt_start, base_mesg_off, mesg_off, row_off, cur_seg;
int row_eqn, col_eqn;
int mpkt_count = s->sp->mpkt_count;
int rpkt_count = s->sp->rpkt_count;
int field_size = s->sp->gfexp;
int seg_count = s->sp->seg_count;
u_int32 *message = s->message;
u_int32 *shares = s->shares;
u_int32 *ExpToFieldElt = s->sp->ExpToFieldElt;
u_int32 *FieldEltToExp = s->sp->FieldEltToExp;
u_int32 MultFieldMax = s->sp->MultFieldMax;
u_int32 topbit = s->sp->topbit;
u_int32 ExpFE = 0;

// loop through shares to be created (aka "redundant" packets) 
for(cur_share=0; cur_share < rpkt_count; cur_share++) {

  pkt_start = cur_share * field_size * seg_count;

  // loop through message packets 
  for(cur_mpkt=0; cur_mpkt < mpkt_count; cur_mpkt++) {

    /* determine start of current message block in message[] */
    base_mesg_off = cur_mpkt*field_size * seg_count;

    ExpFE = (MultFieldMax - FieldEltToExp[cur_share^cur_mpkt^topbit]) % MultFieldMax;
    //printf("ExpFE = %d\n", ExpFE);
    //fflush(stdout);

    /* loop through equation */
    for(row_eqn=0; row_eqn < field_size; row_eqn++) {

      row_off = row_eqn * seg_count + pkt_start;
      for(col_eqn=0; col_eqn < field_size; col_eqn++) {

        /* equation determines what gets XOR'd */
        if (ExpToFieldElt[ExpFE+row_eqn] & BIT[col_eqn]) {

          /* Offset of this segment */
          mesg_off = col_eqn * seg_count + base_mesg_off;

          /* same XOR pattern for entire segment */
          for(cur_seg = 0; cur_seg < seg_count; cur_seg++) {
            shares[row_off + cur_seg] ^= message[mesg_off + cur_seg];
          }
        }

      }

    }
  }
}
return 0;
}
