# #  Copyright (c) 2001 Autonomous Zone Industries
#  This file is licensed under the
#    GNU Lesser General Public License v2.1.
#    See the file COPYING or visit http://www.gnu.org/ for details.
#
# CVS:
__cvsid = '$Id: MojoConstants.py,v 1.14 2001/06/07 23:00:11 greg Exp $'

import os, string

true = 1
false = 0


if string.lower(os.environ.get('EVILDEBUG', 'no')) in ('true', 'yes', 'debug', '1 @m 33v1l',):
    DEBUG_MODE=true
else:
    DEBUG_MODE=false
DEBUG=DEBUG_MODE


DEFAULT_TIMEOUT = 120


# length of RSA public moduli in 8-bit bytes (octets)

# Note that it is allowable for some of the high order bits to be 0.  It is even
# allowable for more than 8 of those bits to be 0 without changing the "length" of the
# modulus.  This is really then the log-base-2 of the size of the space from which we
# randomly choose such values, rather than the "length" of the binary encoding of
# any particular value.

SIZE_OF_MODULAR_VALUES = 1024/8



# Your code should probably be written to work with any public exponent.  It is best not to use
# this constant.  But it is here because mesgen uses it currently.
HARDCODED_RSA_PUBLIC_EXPONENT = 3


# size of ids, secrets, random numbers, salt and other things that must be universally unique
# in 8-bit bytes (octets)
SIZE_OF_UNIQS = 20




USE_REAL_RANDOM_SEED = true # Set this to false to get repeatable tests.  This also, needless to say, gives any attacker all of your secrets and the ability to control your software.  See the debug options at the bottom of this file.
TEST_RANDOMNESS = false # See the debug options at the bottom of this file.



########## settings for testing only!  Be careful to disable these settings for actual use.

#### If you are testing against a network of temporary servers created right here in testing,
# then you can set your keysize to be 656 bits and everyone will be happy.  If you are testing
# against a network of servers out there, they will probably reject your 656 bit keys, so you'll
# have to use 1024 bit keys.
# SIZE_OF_MODULAR_VALUES = 82 # 82 is enough to hold an OAEP-padded string plus a leading 0 byte.  --Zooko 2000-08-01

# This is for faster testing.  It might change the results in a few edge cases, so you should probably comment it out for some test runs?
# DEFAULT_TIMEOUT=50


# This one will screw up tests with multiple separate brokers since they will each generate the same private/public key pair.  ;-)
# USE_REAL_RANDOM_SEED = false

# This one will slow everything down tremendously --it runs slow statistical tests for randomness many many times inside tight loops.
# TEST_RANDOMNESS = true
