#!/usr/bin/env python
#
#  Copyright (c) 2000 Autonomous Zone Industries
#  This file is licensed under the
#    GNU Lesser General Public License v2.1.
#    See the file COPYING or visit http://www.gnu.org/ for details.
#

from DataTypes import UNIQUE_ID, ANY, ASCII_ARMORED_DATA, NON_NEGATIVE_INTEGER, MOD_VAL, INTEGER, NON_NEGATIVE_FLOAT, ListMarker, OptionMarker

from OurMessagesPublicKey import *

TCP_COMM_STRAT_TEMPL = {}
RELAY_COMM_STRAT_TEMPL = {}
CRYPTO_COMM_STRAT_TEMPL = {}
PICKUP_COMM_STRAT_TEMPL = {}

COMM_STRAT_TEMPL = [
    TCP_COMM_STRAT_TEMPL,
    RELAY_COMM_STRAT_TEMPL,
    CRYPTO_COMM_STRAT_TEMPL,
    PICKUP_COMM_STRAT_TEMPL,
    ]

TCP_COMM_STRAT_TEMPL.update({
    'comm strategy type': "TCP",
    'IP address': ANY,
    'port number': NON_NEGATIVE_INTEGER
    })

RELAY_COMM_STRAT_TEMPL.update({
    'comm strategy type': "relay",
    'relayer id': ANY
    })

CRYPTO_COMM_STRAT_TEMPL.update({
    'comm strategy type': "crypto",
    'pubkey': PKFC_TEMPL,
    'lowerstrategy': COMM_STRAT_TEMPL,
    })

PICKUP_COMM_STRAT_TEMPL.update({
    'comm strategy type': "pickup",
    })

# !!! Zooko: make "IP ADDRESS" template item type.  --Zooko 2000/05/12

