#
#  Copyright (c) 2000 Autonomous Zone Industries
#  This file is licensed under the
#    GNU Lesser General Public License v2.1.
#    See the file COPYING or visit http://www.gnu.org/ for details.
#
from DataTypes import UNIQUE_ID, ANY, ASCII_ARMORED_DATA, NON_NEGATIVE_INTEGER, MOD_VAL, ListMarker



# `templs' is a dict from message types to templates that messages of that type must match.
from templs import templs



# This is the formats for our Mojo Token System messages.

WITHDRAW_PROTO_TOKEN_TEMPL = {
    'token id for signing': MOD_VAL,
    'id of public key for verifying this token': UNIQUE_ID
    }

PAYMENT_TOKEN_TEMPL = {
    'token id seed': UNIQUE_ID,
    'token id signature': MOD_VAL,
    'id of public key for verifying this token': UNIQUE_ID
    }



templs['withdraw'] = ListMarker(WITHDRAW_PROTO_TOKEN_TEMPL)
templs['withdraw response'] = [{'result': "failure"}, {'result': "success", 'signed token ids': ListMarker(MOD_VAL) }]

templs['payment'] = ListMarker(PAYMENT_TOKEN_TEMPL)
templs['payment response'] = {'result': ["success", "failure"]}

templs['deposit'] = ListMarker(PAYMENT_TOKEN_TEMPL)
templs['deposit response'] = {'result': ["success", "failure"]}

