#!/usr/bin/env python
#
#  Copyright (c) 2000 Autonomous Zone Industries
#  This file is licensed under the
#    GNU Lesser General Public License v2.1.
#    See the file COPYING or visit http://www.gnu.org/ for details.
#

from FailBasedSelecter import FailBasedSelecter

STANDING = 'standing'
RUNNING = 'running'
STANDING = 'standing'

class Poller:
    def __init__(self, doq, mtm):
        self.doq = doq
        self.mtm = mtm
        self.selecter = FailBasedSelecter(lambda: 60, lambda: 2)
        # status is RUNNING, STOPPING or STANDING
        self.status = STANDING
        
    def start_polling(self):
        assert self.doq.is_currently_doq()
        if self.status == STANDING:
            self.doq.add_task(self.poll)
        self.status = RUNNING
        
    def stop_polling(self):
        assert self.doq.is_currently_doq()
        if self.status == RUNNING:
            self.status = STOPPING

    def poll(self):
        assert self.doq.is_currently_doq()
        if self.status == STOPPING:
            self.status = STANDING
            return
        
        booga

    def poll_result(self, widget, result = None, failure_reason = None):
        assert self.doq.is_currently_doq()
        if failure_reason is not None:
            self.selecter.fail_came_in(widget.get_counterparty_id())
            booga
        else:
            booga

        self.doq.add_task(self.poll, 2)


