#!/usr/bin/env python
#
#  Copyright (c) 2000 Autonomous Zone Industries
#  This file is licensed under the
#    GNU Lesser General Public License v2.1.
#    See the file COPYING or visit http://www.gnu.org/ for details.
#

from Paytool import *

import exceptions


# A SUPER Paytool is a lot like a Paytool, but it automatically withdraws Mojo from your
# TokenServer account if you ask it to do something which requires more Mojo, or a different
# distribution of Mojo, than you have in your purse.


class SuperPaytool(Paytool):
    def __init__(self, cm=None):
        Paytool.__init__(self, cm)


    def _nested_withdrawal_outcome_func(self, conversation, outcome):
        payment_outcome_func = conversation.localmemo['payment_outcome_func']
        paymentconversation = conversation.localmemo['paymentconversation']

        if outcome['result'] == "success":
            # We got the amount we needed.
            # Now try again...
            # (Note that if money has been taken out of this purse since we started this
            # operation, then we may once again get a PurseError and recursively do more
            # withdrawing.  In the case that the TokenServer _account_ is insufficient then
            # we'll know because we get a rejection withdrawal response.)
            self.pay(recipient_id, amount, outcome_func)
            return

        # We got a rejection from the TokenServer?  It must be because we don't have enough Mojo
        # in our account.  Give up!  ##### !!!!! XXXXX TODO Zooko: add feature of depositing MojoTokens in order to get fresh, better distributed ones.  --Zooko 2000/06/13
        payment_outcome_func(paymentconversation, "Not enough Mojo")


    def pay(self, recipient_id, amount, outcome_func = Conversation.default_outcome_call_back_func):
        try:
            Paytool.pay(self, recipient_id, amount, outcome_func)
        except PurseError.NotEnoughMojoError:
            # Hm.  Okay, we'll try to withdraw the minimum Mojo needed to do this payment.
            amountneeded = amount - self.get_amount()

            # Now do a withdrawal for that amount, and when it completes call
            # `_nested_withdrawal_outcome_func()'.
            lopts = make_prototokens(amount)
            wmsgbody = listof_prototokens_to_dict(lopts)

            self._cm.initiate_and_call_back(MojoToken.DEMO_ID_OF_TOKEN_SIGNER,
                                            conversationtype='withdraw', firstmsgbody=wmsgbody,
                                            inmsg_handler_func=self._handle_withdrawal_response,
                                            outcome_call_back_func=self._nested_withdrawal_outcome_func,
                                            localmemo={'lopts': lopts, 'paymentconversation': paymentconversation})
            self.withdraw(amountneeded, 
