#
#  Copyright (c) 2000 Autonomous Zone Industries
#  This file is licensed under the
#    GNU Lesser General Public License v2.1.
#    See the file COPYING or visit http://www.gnu.org/ for details.
#
import threading

class Lock :
    def __init__(self) :
        self.__lk = threading.Lock()
        self.__locked = 0

    def assert_acquired(self) :
        assert self.__locked
        
    def acquire(self) :
        self.__lk.acquire()
        self.__locked = 1
        
    def release(self) :
        assert self.__locked
        self.__locked = 0
        self.__lk.release()
