#ifndef INCL_randsource_methods_hh
#define INCL_randsource_methods_hh

#include "cryptlib.h"

USING_NAMESPACE(CryptoPP)


class RandsourceRandomNumberGenerator : public RandomNumberGenerator {
public:
#ifdef CRYPTOPP_40
        byte GenerateByte();
#else
        byte GetByte();
#endif

#ifdef CRYPTOPP_40
        void GenerateBlock(byte *output,unsigned int size);
#else
        void GetBlock(byte *output,unsigned int size);
#endif
};

class NotEnoughEntropyException : public std::exception {
public:
	explicit NotEnoughEntropyException() { }
	virtual ~NotEnoughEntropyException() { }
};

extern "C"
{
extern void randsource_add(const unsigned char *data,unsigned int amount,unsigned int entropybits);

extern int randsource_get(unsigned char *data,unsigned int amount);
}

#endif // #ifndef INCL_randsource_methods_hh

