#!/usr/bin/env python
#
#  Copyright (c) 2001 Autonomous Zone Industries
#  This file is licensed under the
#    GNU Lesser General Public License v2.1.
#    See the file COPYING or visit http://www.gnu.org/ for details.
#


class wrappedmethod:
    def __init__(self, meth):
        self._meth = meth

    def __call__(self, *args, **kwargs): 
        self._meth.im_self._enter()
        try:
            return apply(self._meth, args, kwargs)
        finally:
            self._meth.im_self._exit()


