#
#  Copyright (c) 2000 Autonomous Zone Industries
#  This file is licensed under the
#    GNU Lesser General Public License v2.1.
#    See the file COPYING or visit http://www.gnu.org/ for details.
#
import exceptions


class zassertError(exceptions.StandardError):
    pass

class PreconditionFailureError(zassertError):
    pass

class PostconditionFailureError(zassertError):
    pass

class AssertionFailureError(zassertError):
    pass

class UnreachableCodeError(zassertError):
    pass

class NotYetImplemented(zassertError):
    pass


def pre(condition, expl=""):
    # return ## !! XX just for testing  --Z
    if not condition:
        raise PreconditionFailureError, expl


def post(condition, expl=""):
    # return ## !! XX just for testing  --Z
    if not condition:
        raise PostconditionFailureError, expl


def zassert(condition, expl=""):
    # return ## !! XX just for testing  --Z
    if not condition:
        raise AssertionFailureError, expl


def unreachable(expl=""):
    # return ## !! XX just for testing  --Z
    raise UnreachableCodeError, expl


def unimplemented(expl=""):
    # return ## !! XX just for testing  --Z
    raise NotYetImplementedError, expl
