#
# Host install-specific configuration for Windows.  It reads an INI file
# and sets environment variables that confutils wants.
#
# $Id: mojohostosconfig.py,v 1.1 2000/08/22 11:13:08 greg Exp $

import os
import sys
import time
import ConfigParser

# the directory where mojonation is installed
if os.path.isfile('mojobroker') :
    os.environ['EVILDIR'] = os.getcwd()
else :
    print "ERROR: MojoNation must be run from your mojonation install directory."
    sys.exit(1)

c = ConfigParser.ConfigParser()
if os.path.isfile("mojonation.ini") :
    c.read("mojonation.ini")
else:
    # XXX TODO put mojonation.ini in a user's ~/.mojonation directory?
    print "ERROR: I couldn't find your mojonation.ini file.  Please"
    print "put a copy in your mojonation install directory."
    sys.exit(1)

#os.environ['EVILDIR'] = c.get('ENVIRONMENT', "EVILDIR")  # we set this above!

# your local mojonation configuration / state directory
try:
    os.environ['EVILCONFDIR'] = c.get('ENVIRONMENT', "EVILCONFDIR")
except:
    print "ERROR: mojonation.ini needs an EVILCONFDIR setting in the ENVIRONMENT section"
    sys.exit(1)

# your "home" directory for storing downloaded files, etc.
try:
    os.environ['HOME'] = c.get('ENVIRONMENT', "HOME")
except:
    print "ERROR: mojonation.ini needs a HOME setting in the ENVIRONMENT section"
    sys.exit(1)

print 'HOME =', os.environ.get('HOME')
print 'EVILDIR =', os.environ.get('EVILDIR')
print 'EVILCONFDIR =', os.environ.get('EVILCONFDIR')
