#!/usr/bin/env python
# Use this invocation so that everyone's Unix setup can find the python interpreter.

#!/usr/bin/env python -O
# Use this invocation is for optimization.

#
#  Copyright (c) 2000 Autonomous Zone Industries
#  This file is licensed under the
#    GNU Lesser General Public License v2.1.
#    See the file COPYING or visit http://www.gnu.org/ for details.
#

import traceback
import sys
import os
# XXX important note!  do -NOT- import any actual mojonation modules
# up here as they may cause the imports and tweaking with
# confutils.confman in the run method below to not work properly.
from MojoConstants import true, false
import MojoConstants

MojoConstants.DEBUG_MODE = true
print '====== Forcing 656-bit modular values during testing. ======'
MojoConstants.SIZE_OF_MODULAR_VALUES = 82 # 82 is enough to hold an OAEP-padded string plus a leading 0 byte.  --Zooko 2000-08-01

modulenames = [
        'BlockServerEGTP',
        'IdTrackerEGTP',
        'MojoTransaction',
        'Paytool',
        'ClientEGTPlib',
        'MetaTrackerLib',
        'Conversation',
        'Cache',
        'MojoKey',
        'MojoToken',
        'mojohttpd',
        'counterparties',
        'idmasklib',
        'Paytool',
        'TCPCommsHandler',
        'CryptoCommsHandler',
    ]


import RunTests
RunTests._testing[0] = true


NAME_OF_THIS_MODULE="spamtest"

mojo_test_flag = 1

def run(verbose=true, outfile="./test-results-full.txt"):
    if not os.environ.has_key('EVILCONFDIR') :
        print 'spamtest will not run without EVILCONFDIR set!  Use testem.sh'
        sys.exit(1)

    import debug
    from confutils import confman
    confman["IGNORE_BAD_IP_ADDRS"] = "testing"  # force always-passing bad address checking during tests
    if verbose:
        confman["MAX_VERBOSITY"] = "99"  # force max verbosity when testing #XXX make this cmd-line configgable!?  --Zooko 2000-08-29
    else:
        confman["MAX_VERBOSITY"] = "0"

    import IdTrackerEGTP
    import MojoTransaction
    import mojoutil
    # # create the localhost root meta tracker
    # print 'creating a test root meta tracker (generating its key)...'
    # root_metatracker_mtm = MojoTransaction.MojoTransactionManager(listenport=3333)
    # confman.dict["ROOT_ID_TRACKER_CONTACT_INFO"]['connection strategies']['0'] = root_metatracker_mtm.get_comm_strategy().toDict()
    # print 'Test Root Meta Tracker ID:', mojosixbit.b2a(root_metatracker_mtm.get_id())
    # # force the localhost root meta tracker to be used with the correct conn strat & public key
    # root_metatracker_mtm.set_id_tracker_info(root_metatracker_mtm.get_metainfo_dict())
    # IdTrackerEGTP.IdTrackerEGTP(root_metatracker_mtm)
    # root_metatracker_mtm.send_hello_to_meta_trackers()

    if verbose:
        RunTests.runTests(modules=modulenames, filename=outfile, verboselevel="spew everything please", testalldeps="yes, please")
    else:
        RunTests.runTests(modules=modulenames, filename=outfile, verboselevel="just dots to stdout but results to file please", testalldeps="yes, please")
    
#### this runs if you import this module by itself
if __name__ == '__main__':
    verbflag=None
    outfilename="./test-results-full.txt"
    if len(sys.argv) > 1:
        if sys.argv[1] == "-v":
            verbflag = true
        else:
            outfilename = sys.argv[1]

        if len(sys.argv) > 2:
            if sys.argv[2] == "-v":
                verbflag = true
            else:
                outfilename = sys.argv[2]
            
    run(verbose=verbflag, outfile=outfilename)

