#!/usr/bin/env python
#
# Starts a self-contained MojoNation network on localhost.
#
# HOW TO USE THIS FILE:
#
# 1) Set your "EVILTOKENDIR" to point to the source tree of your "TokenServer" module.  (ie: Mine is set to "~/sandbox/TokenServer")
#     This environment variable is analogous to "EVILDIR".
# 2) Read the three strings named "commonconfigopts", "merchantconfigopts", and "userconfigopts" and change the settings to your liking.
#     "commonconfigopts" is used by every process that is started.  "merchantconfigopts" is only used by the "Merchant-Side" broker, and
#     "userconfigopts" is its obvious analog.
# 3) Scan down to the comment with "COME HERE TO CHANGE WHICH THINGIES TO RUN".  Below it you will see a tuple of dicts.
#     The tuple order is the order these commands are run in.  I hope the dict format is obvious.  Comment out stuff you don't want to run.
# 4) Before running this script, realize these things:
#     - For each command run, a new broker directory is created with the confutils FS tree as well as the log file.
#     - By default all of these broker directories are placed under /tmp.  You can change this by changing your "TMP_DIR" environment variable
#        or by giving this script "--basedir=<DIR NAME>".  That last feature is not really tested, and if you find that it is broken, fix it!
#     - Each directory is named after the 'name' field in the command dict.
#
# 5) Run the script.  Fix the bugs.  The script does not kill the processes it spawns.  You must kill them yourself.  I use
#     utilscripts/killinteractive.sh which works like this: show `ps x`.  Read a line of input.  If the input is empty, exit.
#     Else: Kill -15 that process, sleep 3, repeat.
#
# 6) When something breaks, don't bug the Nefarious Junior Code Monkey, unless you bring Mojo or bananas with which to bribe him.
#
#
# Standard Modules:
import os, re, string, time

# FUNKITY STUPID HACK, figure it out for yourself:
os.environ['EVILCONFDIR'] = '/tmp/RootMetaTracker'

# Mojo Modules:
import MojoTransaction
from MojoConstants import true, false
import mencode
import mojoutil
import Paytool
import SEXP
import confutils
import mesgen

commonconfigoptswrapper={'thingie': {}}
initccodict = {
    'AGREED_TO_TERMS_OF_SERVICE': "yes",
    'ENCRYPT_LOCAL_KEYS': "no",
    'AUTO_LAUNCH_BROWSER' : "no",
    }
commonconfigoptswrapper['thingie'].update(initccodict)

# This is a temporary hack to test the TCP connection maintainence, in order to catch the TCP read queue bug:
commonconfigoptswrapper.update({
    'TCP_MAINTAINED_CONNECTIONS': 3,
    'TCP_MAX_CONNECTIONS': 3,
    })

# This one covers all blocks and runs the publication agent/tracker.
merchantAconfigopts="""\
BLOCKSERVER:
\tLIST_OF_BLOCKID_MASKS:
\t\t0:
\t\t\tbits: 0
\t\t\tmask: AA
\tSELECTED_MASK_PROPERLY: yes
\tSECONDS_BETWEEN_PUBLISHING_AGENT_POLLS_v3: 33
YES_NO:
\tRUN_BLOCK_SERVER: yes
\tBLOCK_SERVER_ALLOWS_PUBLISHING: yes
\tALLOW_WALLET_IN_LOCALHOST_GATEWAY: yes
\tRUN_CONTENT_TRACKER: yes
\tRUN_LOCALHOST_GATEWAY: no
\tRUN_META_TRACKER: no
\tRUN_MOJOPUBLISHER_GUI: no
\tRUN_PUBLISH_AGENT: yes
\tRUN_RELAY_SERVER: no
PUBLICATIONTRACKERHANDLERS:
\tallows store location information: yes
\tmask:
\t\tbits: 0
\t\tmask: Mg
"""

# This one only server 1/4 of the blocks, but does so for -real-
# cheap; this should cause pricing and the publication agent to be
# tested.
merchantBconfigopts="""\
BLOCKSERVER:
\tLIST_OF_BLOCKID_MASKS:
\t\t0:
\t\t\tbits: 2
\t\t\tmask: AA
\tSELECTED_MASK_PROPERLY: yes
\tPRICE_MAPS:
\t\tHAVE BLOCK: 2
\t\tPUBLISH:
\t\t\t1: 1
\t\t\t16: 2
\t\t\t128: 3
\t\tRETRIEVE:
\t\t\t1: 2
\t\t\t16: 4
\t\t\t128: 7
\tSECONDS_BETWEEN_PUBLISHING_AGENT_POLLS_v3: 25
YES_NO:
\tRUN_BLOCK_SERVER: yes
\tBLOCK_SERVER_ALLOWS_PUBLISHING: yes
\tALLOW_WALLET_IN_LOCALHOST_GATEWAY: yes
\tRUN_CONTENT_TRACKER: yes
\tRUN_LOCALHOST_GATEWAY: no
\tRUN_META_TRACKER: no
\tRUN_MOJOPUBLISHER_GUI: no
\tRUN_PUBLISH_AGENT: yes
\tRUN_RELAY_SERVER: no
PUBLICATIONTRACKERHANDLERS:
\tallows store location information: no
\tPRICES:
\t\tRETRIEVE: 1
\t\tSTORE: 1
\tmask:
\t\tbits: 1
\t\tmask: AA
\tpoll delay: 15
"""

userconfigopts="""\
YES_NO:
\tRUN_BLOCK_SERVER: no
\tALLOW_WALLET_IN_LOCALHOST_GATEWAY: yes
\tRUN_CONTENT_TRACKER: no
\tRUN_LOCALHOST_GATEWAY: yes
\tRUN_META_TRACKER: no
\tRUN_MOJOPUBLISHER_GUI: no
\tRUN_PUBLISH_AGENT: no
\tRUN_RELAY_SERVER: no
METATRACKERLIB:
\tMIN_CACHED_RESULTS_TO_PREVENT_RETRY_LOOKUP_v4: 1
"""

lineforallforcedconfigs = "IGNORE_BAD_IP_ADDRS: testing\nSECONDS_BEFORE_ALLOWING_A_RETRY_LOOKUP_v3: 60\n"

#lineforverbosediagnostics = "MAX_VERBOSITY: 99\nDEBUG_MODE: yes\n"
lineforverbosediagnostics  = '' # Not verbose.

interfaces = {
        'spawn' : {
                'with-log' : 'export EVILCONFDIR="%s" ; cd "%s" ; %s > %s 2>&1 &',
                'no-log' : 'export EVILCONFDIR="%s" ; cd "%s" ; %s &',
            },
    }


def spawn_child(commandstr, evilconfdir, configopts="", logfile=None, clean=false,
                isrootmetatracker=0, commonconfigoptswrapper=commonconfigoptswrapper):
    print "Executing %s." % os.path.basename(string.split(commandstr)[0])
    if clean :
        print 'Cleaning "%s".' % evilconfdir
        os.system('rm -rf %s' % evilconfdir)

    print "Configuring Broker."
    try:
        os.makedirs(os.path.join(evilconfdir, 'broker'))
    except OSError, x:
        if x.errno == 17:
            # Okay it already exists
            pass
        else:
            raise x

    # Special case for rootmetatracker:
    if isrootmetatracker:
        dbparentdir="/tmp"
        mesgen4metatracker = mesgen.create_MessageMaker(dbparentdir, recoverdb=true)

        commandstr = "%s '%s'" % (commandstr, mencode.mencode({'session keeper': mesgen4metatracker._session_keeper.serialize()}))

        commonconfigoptsdict = {
            'ROOT_ID_TRACKER_CONTACT_INFO': {
                'connection strategies': SEXP.listToDict([{
                    'comm strategy type': "crypto",
                    'lowerstrategy': {
                        'IP address': "127.0.0.1",
                        'comm strategy type': "TCP",
                        'port number': "3333"
                        },
                    'pubkey': mencode.mdecode(mesgen4metatracker.get_public_key()),
                    }])
                }
            }
        commonconfigoptswrapper['thingie'].update(commonconfigoptsdict)
        print "I think I am a root metatracker."


    totalconfigopts = string.join(confutils.dict_to_lines(commonconfigoptswrapper['thingie'])) + configopts
    if totalconfigopts[-1:] != '\n' :
        totalconfigopts = totalconfigopts + '\n'
    totalconfigopts = totalconfigopts + lineforallforcedconfigs + lineforverbosediagnostics 
    conffile = open(os.path.join(evilconfdir, 'broker/broker.conf'), 'w')
    conffile.write(totalconfigopts)
    conffile.flush()
    conffile.close()

        
    if logfile:
        logfile = os.path.join(evilconfdir, logfile)
        print 'Using logfile "%s".' % logfile
        os.system('cd %s; rm -f mojolog-current; ln -s %s mojolog-current' % (evilconfdir, logfile)) # Create a current symlink.
        command = interfaces['spawn']['with-log'] % (evilconfdir, evilconfdir, commandstr, logfile)
        status = os.system(command)
    else:
        command = interfaces['spawn']['no-log'] % (evilconfdir, evilconfdir, commandstr)
        status = os.system(command)
    print "Status:", status
    return not status # True if spawn succeeds, false if spawn failed.

def main(argv=()):
    developer = true
    clean = false
    if "TMP_DIR" in os.environ.keys() :
        basedir = os.environ["TMP_DIR"]
    else:
        basedir = "/tmp/"
    
    # Handle args:
    options, args = getopt.getopt(argv, '', ['basedir:', 'clean'])
    for option, value in options :
        if option == '--basedir' :
            basedir = value
        elif option == '--clean' :
            clean = true
        elif option == '--developer' :
            developer = true
        else:
            raise SystemExit, 'Unkown option "%s"!' % option

    if developer and not ("EVILTOKENDIR" in os.environ.keys()) :
        print "Developers must define the environment variable EVILTOKENDIR to run the Token Server enabled version of this script."
        raise SystemExit

    if developer :
        # If you COME HERE TO CHANGE WHICH THINGIES TO RUN and change the following tuple, you can customize things.
        commandtuple = (
                {
                    'name' : 'RootMetaTracker',
                    'command' : os.path.join(os.environ["EVILDIR"], "server/merchant/IdTrackerEGTP.py") + ' 3333',
                    'specialconfigopts' : "",
                    'delay' : 5,
                    'isrootmetatracker' : 1,
                },
                {
                    'name' : 'TokenServer',
                    'command' : os.path.join(os.environ["EVILTOKENDIR"], "RunTokenServer.py"),
                    'specialconfigopts' : "",
                    'delay': 5,
                },
                {
                    'name' : 'MerchantBrokerA',
                    'command' : os.path.join(os.environ["EVILDIR"], "Broker --no-log-file"),
                    'specialconfigopts' : merchantAconfigopts,
                    # 'delay' : 10,
                },
                {
                    'name' : 'MerchantBrokerB',
                    'command' : os.path.join(os.environ["EVILDIR"], "Broker --no-log-file"),
                    'specialconfigopts' : merchantBconfigopts,
                    # 'delay' : 10,
                },
                {
                    'name' : 'UserBroker',
                    'command' : os.path.join(os.environ["EVILDIR"], "Broker --no-log-file"),
                    'specialconfigopts' : userconfigopts,
                },
            )
    else:
        brokennote = """\
XXX - You need to connect your Contained MojoNation (tm) network to the alpha token server...  The alpha token server must announce
itself to your root metatracker.  Currently we have no fix for this, so this script isn't much use (just run a Broker on alpha test MojoNation(tm)).
"""
        raise SystemExit, brokennote

    for d in commandtuple :
        confdir = os.path.join(basedir, d['name'])
        timestr = time.strftime("%Y-%m-%d_%H:%M:%S", time.gmtime(time.time()))
        if not spawn_child(d['command'], confdir, d['specialconfigopts'], "mojolog-"+str(timestr), 
                           clean=clean, isrootmetatracker=d.get('isrootmetatracker')):
            print "Ugh, I'm dying!"
            raise SystemExit
        delay = d.get('delay', 0)
        if delay :
            print "Delay", delay
            os.system("sleep %d" % delay)

    print "To kill the running processes, I suggest $EVILDIR/utilscripts/killemall.sh"
    print "Now git to testin' that Beta Mojo!"
    raise SystemExit

if __name__ == '__main__' :
    import sys, getopt
    main(sys.argv[1:])
