#!/usr/bin/env python
#
# Starts a self-contained MojoNation network on localhost with on
# broker sending pings to the other.
#
# Standard Modules:
import os, re, string, time

tmpdir = os.environ.get('TMP_DIR', '/usr/tmp')
assert os.path.isdir(tmpdir), 'your TMP_DIR environment variable must point to a temporary directory'

# FUNKITY STUPID HACK, figure it out for yourself:
os.environ['EVILCONFDIR'] = os.path.join(tmpdir, 'RootMetaTracker')

if not os.environ.get('PYTHON'):
    print 'PYTHON environment variable must be set.'
    raise SystemExit

# Mojo Modules:
from MojoConstants import true, false
import mencode
import mojoutil
import SEXP
import confutils
import fileutil
import mesgen
import idlib

commonconfigoptswrapper={'thingie': {}}
initccodict = {
    'AGREED_TO_TERMS_OF_SERVICE': "yes",
    'ENCRYPT_LOCAL_KEYS': "no",
    'AUTO_LAUNCH_BROWSER' : "no",
    'EXTENSION_MODS' : {'0': 'PingPongTest'},
    'DUPLICATE_PROCESS_SANITY_CHECK' : 'no', # Don't check for other brokers running...  Currently this clashes and works wrong with ESCM.
    'CONN_SPEED_IN': '1234',
    'CONN_SPEED_OUT': '876',
    'BOOTPAGE_URL': "http://localhost:7777/bootpage.txt",   # the metatracker we start serves this
    'METATRACKERLIB': {
            "TIME_BETWEEN_EXTRA_CONTACT_REFRESH": str(61),
        },
    }
commonconfigoptswrapper['thingie'].update(initccodict)

# This is a temporary hack to test the TCP connection maintainence, in order to catch the TCP read queue bug:
commonconfigoptswrapper.update({
    'TCP_MAINTAINED_CONNECTIONS': 3,
    'TCP_MAX_CONNECTIONS': 8,
    })

# Temporary hack for Central Services:
metatrackerconfigopts="""\
IP_ADDRESS_OVERRIDE: 127.0.0.1
TRANSACTION_MANAGER_LISTEN_PORT: %d
TRANSACTION_MANAGER_PICKY_PORT: true
YES_NO:
\tRUN_BLOCK_SERVER: no
\tRUN_CONTENT_TRACKER: no
\tRUN_LOCALHOST_GATEWAY: yes
\tRUN_META_TRACKER: yes
\tRUN_PUBLISH_AGENT: no
\tRUN_RELAY_SERVER: no
"""

# This one covers all blocks and runs the publication agent/tracker.
Pingconfigopts="""\
YES_NO:
\tRUN_BLOCK_SERVER: no
\tRUN_CONTENT_TRACKER: no
\tRUN_LOCALHOST_GATEWAY: no
\tRUN_META_TRACKER: no
\tRUN_PUBLISH_AGENT: no
\tRUN_RELAY_SERVER: no
"""

Pongconfigopts="""\
PROFILING: yes
MAX_REQUEST_HANDLER_DELAY: 15
YES_NO:
\tRUN_BLOCK_SERVER: no
\tRUN_CONTENT_TRACKER: no
\tRUN_LOCALHOST_GATEWAY: no
\tRUN_META_TRACKER: no
\tRUN_PUBLISH_AGENT: no
\tRUN_RELAY_SERVER: no
"""

lineforallforcedconfigs = "IGNORE_BAD_IP_ADDRS: testing\nSECONDS_BEFORE_ALLOWING_A_RETRY_LOOKUP_v3: 60\n"

#lineforverbosediagnostics = "MAX_VERBOSITY: 99\n"
lineforverbosediagnostics = "MAX_VERBOSITY: 2\n"
#lineforverbosediagnostics  = '' # Not verbose.

interfaces = {
        'spawn' : {
                'with-log' : 'export EVILCONFDIR="%s" ; cd "%s" ; %s > %s 2>&1 &',
                'no-log' : 'export EVILCONFDIR="%s" ; cd "%s" ; %s &',
            },
    }

PREV_BROKER_ID = ''  # this is set to the previously spawned broker's ascii broker id

def spawn_child(commandstr, evilconfdir, configopts="", logfile=None, clean=false,
                rootmetatrackerport=0, commonconfigoptswrapper=commonconfigoptswrapper, brokermt=true,
                pregenerate_key=1):
    global PREV_BROKER_ID
    commandstr = string.replace(commandstr, 'PREV_BROKER_ID', PREV_BROKER_ID)
    print "Preparing to execute %s" % commandstr
    if clean :
        print 'Cleaning "%s".' % evilconfdir
        os.system('rm -rf %s' % evilconfdir)

    print "Configuring."
    try:
        os.makedirs(os.path.join(evilconfdir, 'broker'))
    except OSError, x:
        if x.errno == 17:
            # Okay it already exists
            pass
        else:
            raise x

    # Special case for rootmetatracker:
    if rootmetatrackerport or pregenerate_key:
        dbparentdir=tmpdir
        print "generating a broker key..."
        mesgen4metatracker = mesgen.create_MessageMaker(dbparentdir, recoverdb=true)

        # If we're running the metatracker as a broker, go through a bunch of steps to set up the keys correctly:
        if brokermt:
            mtmdir = os.path.join(evilconfdir, 'broker', 'mtmdb', idlib.to_ascii(mesgen4metatracker.get_id()))
            fileutil.make_dirs(mtmdir)
            fileutil.make_dirs(os.path.join(mtmdir, 'cos'))
            fileutil.make_dirs(os.path.join(mtmdir, 'mesgen'))
            f = open(os.path.join(mtmdir, 'key'), 'wb')
            f.write(mesgen4metatracker._session_keeper.serialize())
            f.close()
            configopts = "PMTM_ID: %s\n" % (idlib.to_ascii(mesgen4metatracker.get_id()),) + configopts
        else:
            commandstr = "%s '%s'" % (commandstr, mencode.mencode({'session keeper': mesgen4metatracker._session_keeper.serialize()}))

        PREV_BROKER_ID = idlib.to_ascii(mesgen4metatracker.get_id())
        print PREV_BROKER_ID

        if rootmetatrackerport:
            commonconfigoptsdict = {
                'ROOT_ID_TRACKER_CONTACT_INFO': {
                    'connection strategies': SEXP.listToDict([{
                        'comm strategy type': "crypto",
                        'lowerstrategy': {
                            'IP address': "127.0.0.1",
                            'comm strategy type': "TCP",
                            'port number': str(rootmetatrackerport),
                            },
                        'pubkey': mencode.mdecode(mesgen4metatracker.get_public_key()),
                        }])
                    }
                }
            commonconfigoptswrapper['thingie'].update(commonconfigoptsdict)
            print "I think I am a root metatracker."


    totalconfigopts = string.join(confutils.dict_to_lines(commonconfigoptswrapper['thingie'])) + configopts
    if totalconfigopts[-1:] != '\n' :
        totalconfigopts = totalconfigopts + '\n'
    totalconfigopts = totalconfigopts + lineforallforcedconfigs + lineforverbosediagnostics 
    conffile = open(os.path.join(evilconfdir, 'broker/broker.conf'), 'w')
    conffile.write(totalconfigopts)
    conffile.flush()
    conffile.close()


    # remove previous ESCM run saved metainfo as it no longer applies.
    try:
        os.unlink(os.path.join(evilconfdir, 'broker', 'saved_metainfo.pickle'))
    except (IOError, OSError):
        pass

    if logfile:
        logfile = os.path.join(evilconfdir, logfile)
        print 'Using logfile "%s".' % logfile
        os.system('cd %s; rm -f mojolog-current; ln -s %s mojolog-current' % (evilconfdir, logfile)) # Create a current symlink.
        command = interfaces['spawn']['with-log'] % (evilconfdir, evilconfdir, commandstr, logfile)
        status = os.system(command)
    else:
        command = interfaces['spawn']['no-log'] % (evilconfdir, evilconfdir, commandstr)
        status = os.system(command)
    print "Status:", status
    print
    return not status # True if spawn succeeds, false if spawn failed.

def main(argv=()):
    clean = false
    brokermt = true # If true use a Broker to start the meta tracker, else use IdTrackerEGTP.py.
    basedir = tmpdir
    
    # Handle args:
    options, args = getopt.getopt(argv, '', ['basedir:', 'clean', 'no-brokermt'])
    for option, value in options :
        if option == '--basedir' :
            basedir = value
        elif option == '--clean' :
            clean = true
        elif option == '--no-brokermt':
            # Use the old non-Broker class/script to run the metatracker:
            brokermt = false
        else:
            raise SystemExit, 'Unkown option "%s"!' % option

    global metatrackerconfigopts
    if brokermt:
        metatrackerconfigopts = metatrackerconfigopts % 20305    # value from standalone/CentralMetaTracker.py
    else:
        metatrackerconfigopts = metatrackerconfigopts % 3333     # value from below passed to IdTrackerEGTP

    # If you COME HERE TO CHANGE WHICH THINGIES TO RUN and change the following tuple, you can customize things.
    commandlist = (
            {
                'name' : 'RootMetaTracker',
                # The 'command' is set later, according to brokermt
                'specialconfigopts' : metatrackerconfigopts,
                'delay' : 10,
            },
            {
                'name' : 'EchoResponder',
                'command' : os.path.join(os.environ["EVILDIR"], "Broker --no-log-file"),
                'specialconfigopts' : Pongconfigopts,
                # 'delay' : 10,
            },
            {
                'name' : 'PingBroker',
                'command' : os.environ['PYTHON'] + ' ' + os.path.join(os.environ["EVILDIR"], "client/localhost/Broker.py --no-log-file --ping PREV_BROKER_ID"),
                'specialconfigopts' : Pingconfigopts,
                # 'delay' : 10,
            },
        )
    if brokermt:
        # run the root metatracker the more modern way
        commandlist[0]['command'] = os.path.join(os.environ["EVILDIR"], "standalone/CentralMetaTracker.py --no-log-file")
        commandlist[0]['rootmetatrackerport'] = 20305
    else:
        commandlist[0]['command'] = os.path.join(os.environ["EVILDIR"], "server/merchant/IdTrackerEGTP.py") + ' 3333' # The old way.
        commandlist[0]['rootmetatrackerport'] = 3333

    for d in commandlist :
        confdir = os.path.join(basedir, d['name'])
        timestr = time.strftime("%Y-%m-%d_%H:%M:%S", time.gmtime(time.time()))
        if not spawn_child(d['command'], confdir, d['specialconfigopts'], "mojolog-"+str(timestr), 
                           clean=clean, rootmetatrackerport=d.get('rootmetatrackerport', 0), brokermt=brokermt):
            print "Ugh, I'm dying!"
            raise SystemExit
        delay = d.get('delay', 0)
        if delay :
            print "Delay", delay
            os.system("sleep %d" % delay)

    print "To kill the running processes, I suggest $EVILDIR/utilscripts/killemall.sh"
    raise SystemExit

if __name__ == '__main__' :
    import sys, getopt
    main(sys.argv[1:])

