#! /bin/bash

echo 'I AM THE CURRENT VERSION!  FEAR ME!'
echo ${CVSVER}
# This is the current autotest.sh
EVILDIR=/home/zooko/evil
EXTSRCDIR=/home/zooko/extsrc

TESTEMSCRIPT="./testem.sh"
TESTRESFILE="test-res.txt"
TESTLOGFILE="test-log.txt"
AUTOTESTRESFILE="auto-test-res.txt"

RECIPLIST="zooko@mad-scientist.com"

TEMPDIR="/tmp"

cd $EXTSRCDIR
cvs update -Pd

cd $EVILDIR
cvs update -Pd

make all

rm ${TESTLOGFILE}
rm ${TESTRESFILE} 

${TESTEMSCRIPT}

rm ${TESTLOGFILE}
mv ${TESTRESFILE} ${AUTOTESTRESFILE}

TEMPDIFFFILE="${TEMPDIR}/autotest.diff.$$"
TEMPMAILFILE="${TEMPDIR}/autotest.mail.$$"

cvs diff -u ${AUTOTESTRESFILE} 2>&1 > ${TEMPDIFFFILE}
DIFFSTR=`cat ${TEMPDIFFFILE}`
if [ "X${DIFFSTR}" != "X" ]
then
    cvs commit -f -m'auto test commit' ${AUTOTESTRESFILE}

    echo "To: ${RECIPLIST}" >> ${TEMPMAILFILE}
    echo "Subject: automated test results" >> ${TEMPMAILFILE}
    echo "--------" >> ${TEMPMAILFILE}
    echo "This is the automated testing script.  I have noticed a change in our test results.  A cvs diff of auto-test-res.txt is included below." >> ${TEMPMAILFILE}
    echo "--------" >> ${TEMPMAILFILE}
    echo "" >> ${TEMPMAILFILE}
    echo "" >> ${TEMPMAILFILE}
    cat ${TEMPDIFFFILE} >> ${TEMPMAILFILE}

    send ${TEMPMAILFILE}
else
    # It is identical.  We happy.
    echo test results have not changed
fi

echo "I AM DONE DOING THE AUTOTEST" >> /var/tmp/autotest-done-flag
