#! /bin/bash

# This script, which should probably be run every hour or so, does a full cvs update and build and then
# runs `testem.sh' and then if the resulting `test-log.txt' is different from the latest version of 
# `test-log.txt' in CVS then it mails to evgen@mad-scientist.com.

# Note: it would be cool if this script got run in response to user commits but I don't want to screw
# with that.

CVSVER="$Id: autotest.sh,v 1.1.1.1 2000/08/02 20:24:05 nejucomo Exp $"

SELF=./autotest.sh
GUTS=./autotest-guts.sh

CLEANER=./cleaner.sh



if cvs status ${SELF} 2>&1 | grep "Needs Patch"
then
    # There is a new autotest.sh
    echo "UPDATING SELF BEFORE TESTING"
    cvs update -Pd ${SELF}
    cvs update -Pd ${GUTS}
    ${SELF}
else
    RECIPLIST="zooko@mad-scientist.com"
    TEMPDIR="/tmp"

    rm /var/tmp/autotest-done-flag

    cvs update -Pd ${GUTS}

    ${GUTS} &

    sleep 1800 # 30 minutes

    if grep "DONE" /var/tmp/autotest-done-flag
    then
        echo pass
    else
        kill %1

        # Now kill all processes that might be left by tests...
        ${CLEANER}

        TEMPMAILFILE="${TEMPDIR}/autotest.mail.$$"

        echo "To: ${RECIPLIST}" >> ${TEMPMAILFILE}
        echo "Subject: automated test results" >> ${TEMPMAILFILE}
        echo "--------" >> ${TEMPMAILFILE}
        echo "This is the automated testing script.  I have noticed that testem.sh doesn't terminate after 30 minutes.  Bummer."  >> ${TEMPMAILFILE}
        echo "Please go look in vonneumann:/home/zooko/evil for details."  >> ${TEMPMAILFILE}

        send ${TEMPMAILFILE}
    fi
    
fi
