#!/usr/bin/env python


# Simple func to benchmark a func for its behavior with respect to N...


import time


def makeg(func):
    def blah(n, func=func):
        for i in xrange(n):
            func()
    return blah

def rebenchit(func, n, initfunc=None, REPS=5):
    sum = 0
    num = 0
    for K in xrange(REPS):
        if initfunc:
            initfunc(n)
        tl = benchit(func, n)
        if tl > 0:
            sum = sum + tl
            num = num + 1

    if num > 0:
        timelapsed = sum / num
    else:
        timelapsed = 0

    if timelapsed == 0.0:
        print "ave. N: %d, time: 0.0, rate: N/A" % n
    else:
        print "ave. N: %d, time: %f, rate: %0.0f" % (n, timelapsed, (n / timelapsed))
   
def benchit(func, n):
    st = time.clock()
    func(n)
    sto = time.clock()

    timelapsed = sto - st

    return timelapsed

BSIZES = []
for i in range(21):
    BSIZES.append(2 ** i)

def bench(func, initfunc=None):
    for BSIZE in BSIZES:
        rebenchit(func, BSIZE, initfunc=initfunc)

   
