#!/usr/bin/env python

# If run as a script, this prints your portnum and privacy code to stdout.

# You can also call it Pythonically: snarfprivacycode.snarfprivacycode() returns a tuple of (port, privacy_code).

# (Note: yeah, there are security implications.  But privacy codes are really a temporary fix for security anyway.)



import os, re, sys


def snarfprivacycode():
    # EVILCONFDIR
    EVILCONFDIR = os.environ.get("EVILCONFDIR")

    if not EVILCONFDIR:
        EVILCONFDIR=os.path.join(os.environ["HOME"], ".mojonation")

    Intropage_Filename = os.path.join(EVILCONFDIR, "broker", "intropage.html") #???  We still use ".html" instead of ".HTM" or something even on Win32 right?  --Zooko 2000-08-11

    # sample first line: # <!-- Port: 4004 PrivacyCode: 31jlMwkwgEY4jPKA -->

    # snarfed from MojoMunchy.py, then munged a bit.

    # this is used to get info about the running broker from its intropage
    extract_brokerinfo_re = re.compile(r'-- Port: (?P<port>\d+) PrivacyCode: (?P<privacycode>\S*) --', re.I)

    try:
        ipfile = open(Intropage_Filename, "r")
        m = extract_brokerinfo_re.search(ipfile.readline())
        if m :
            return (int(m.group('port')), m.group('privacycode'))
    except:
        sys.stderr.write('error reading intropage %s\n' % Intropage_Filename)
        raise


def run():
    (port, privacy_code) = snarfprivacycode()

    sys.stdout.write(`port` + "\n")
    sys.stdout.write(str(privacy_code) + "\n")

    sys.stdout.flush()


#### this runs if you import this module by itself
if __name__ == '__main__':
    run()


