#! /usr/bin/env python
#
# Attempts to stop a running Broker by making an
# http request to it.

# Standard Modules:
import string
import socket
# We don't use urllib because it does too much
# behind the scenes and gordon's installer didn't
# recognize all of its dependencies.

# Mojo Nation Modules:
import snarfprivacycode

# Constants:
DEBUG = 0
HTTP_GET = 'GET /%s/broker/shutdown HTTP/1.0\r\n\r\n'

# Functions:
def debug(output):
    if DEBUG:
        print output
        
def main(argv=()):
    port, pc = snarfprivacycode.snarfprivacycode()
    if check_response(retrieve_url(port, pc)):
        print "Request successful."
        return 0
    else:
        print "Request failed."
        return 1
    
def retrieve_url(port, pc):
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    s.connect(('localhost', port))
    request = HTTP_GET % pc
    debug(`request`)
    s.send(request)
    buf = ''
    input = s.recv(1024)
    while input:
        buf += input
        debug(`input`)
        input = s.recv(1024)
    return buf

def check_response(html):
    html = string.join(string.split(html)) # Normalize whitespace.
    index = string.find(html, 'Your mojo nation broker is shutting down...')
    return index != -1

if __name__ == '__main__':
    import sys
    sys.exit(main(sys.argv))
