#!/bin/sh

LOGFILENAME="watchforlisten.log"

if [ "X${1}" = "X" ]
then
    PORT=20001
else
    PORT="${1}"
fi

if netstat -an |  grep -q "0.0.0.0:${PORT}.*LISTEN"
then
    mv --backup ${LOGFILENAME} ${LOGFILENAME}~
    export DONE=nope
    echo "He is listening on port ${PORT}.  Watch to see when he stops listening..."
    echo "He is listening on port ${PORT}.  Watch to see when he stops listening..." > ${LOGFILENAME}
else
    echo "WARNING: he was not listening on port ${PORT}.  Not starting."
    echo "WARNING: he was not listening on port ${PORT}.  Not starting." > ${LOGFILENAME}
    export DONE=yep
fi

(
    while [ "X${DONE}" = "Xnope" ] ; 
    do
	sleep 1
	if ! netstat -an 2>/dev/null |  grep -q "0.0.0.0:${PORT}.*LISTEN"
	then
	    date --utc
	    echo "no listen"
	    netstat -anvvv
	    ps eawwxv
	    export DONE="yep"
	fi
    done
) >> ${LOGFILENAME}.log 2>&1 & 
