#ifndef CONNECTIONS_H
#define CONNECTIONS_H

#include "qobject.h"

class QtellaSub;
class QListViewItem;
class QWidget;
class Servent;
class QueryHitEntry;
class SearchWidget;
class Search;

#include <vector>
#include <string>

class Connections : QObject
{
  Q_OBJECT

 public:
  Connections(QWidget *parent = 0);
  void       start();
  void       check_servents();
  void       search(string query, SearchWidget *sw);

  vector<class Search*>     vSearch;
  vector<class Servent*>    vServent;

 protected:
  int        max_servents;
  int        max_hosts_in_hostlist;

  void       checkVectors(Servent *s);

  class QtellaSub  *parent;

 private:
  string                    id;
  string                    id2str(string id);


  public slots:

  void     slotRemoveHost();
  void     slotAddHost();
  void     slotMaxServents(int value);
  void     slotListClear();
  void     slotListRemove();
  void     slotListConnect();
};

#endif
