#ifndef QTELLASUB_H
#define QTELLASUB_H

#include <string>
#include <vector>

class QMenuBar;
class Connections;
class DownloadThread;
class SharedFile;
class UploadManager;
class QTimer;

#include "qthread.h"

#include "Qtella.h"

#ifdef KDE
#include "kmenubar.h"
#include "kpopupmenu.h"
#endif KDE

class QtellaSub : public Qtella
{ 
    Q_OBJECT

 public:
    QtellaSub( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~QtellaSub();

    #ifdef KDE
    KMenuBar             *menu;
    #endif

    #ifdef QT
    QMenuBar             *menu;
    #endif

    class Connections    *connections;

    QTimer               *timer_connection;
    QTimer               *timer_refresh_downloads;

    vector<SharedFile*>  readSharedFiles();
    vector<SharedFile*>  vSharedFiles;
    
    unsigned long        number_shared_files;
    unsigned long        shared_size;
    
    static void          sighandler(int);

    int                  readNumberOfDownloads();

 public slots:
      
    void connection();
    void check_connections();
    void myquit();
    void slotInfo();

    virtual void slotRefreshSharedList();
    virtual void slotSearch();
    virtual void slotAddDirectory();
    virtual void slotRemoveDirectory();
    virtual void slotApplyConfig();
    virtual void slotSearchDoubleClicked(QListViewItem*);
    virtual void slotRefreshDownloads();
    virtual void slotClearSearchlist();
    virtual void slotDownloadAll();
    virtual void slotRemoveDownload();
    virtual void slotResumeDownload();
    virtual void slotAbortDownload();
    virtual void slotAddAutoConnect();
    virtual void slotRemoveAutoConnect();
    virtual void slotAddHost();
    virtual void slotAbortUpload();
    virtual void slotRemoveUpload();
    virtual void slotDeleteSharedFile();
    virtual void slotClearInactiveDownloads();
    virtual void slotClearInactiveUploads();

 private:
    void                     downloadItem(QListViewItem *item);
    void                     readConfiguration();

    string                   conffile;
    vector<DownloadThread*>  vDownloadThreads;
    int                      search_tabs;

    QMutex                   mutex_shared_files;
    UploadManager            *upload_manager;
};

#endif // QTELLASUB_H
