#ifndef UPLOADTHREAD_H
#define UPLOADTHREAD_H

#include "qthread.h"
#include "qobject.h"

#include <string>

class QSocket;
class UploadManager;
class QListViewItem;

class UploadThread : public QObject, public QThread
{
 Q_OBJECT

 public:
  UploadThread(UploadManager *parent, int socket, int state);
  ~UploadThread();

  void startUpload();
  int  getState();
  void setState(int state);
  void abortUpload();

  enum {  
    Busy,
    Start,
    Connected,
    NotFound,
    Finished,
    Error,
    Abort,
    Closed
  };

  QListViewItem  *item;

 private:
  virtual void run();

  QSocket        *socket;
  string         client;
  unsigned long  index;
  unsigned long  range_start;
  unsigned long  range_end;
  string         filename;
  int            state;

  UploadManager  *parent;

  static const string statestr[];

 public slots:
  void slotClosed();
};

#endif
