#include "QueryHit.h"
#include "Errors.h"

QueryHit::QueryHit(string id, int ttl, int hops, string queryresult) throw(long)
{
  string qh = queryresult;

  this->ttl = ttl;
  this->hops = hops;
  this->id = id;

  unsigned char      hits  = *((unsigned char*)qh.substr(0, 1).c_str());
  unsigned short int port  = *((unsigned short int*)qh.substr(1, 2).c_str());
  unsigned long      ip    = *((unsigned long*)qh.substr(3, 4).c_str());
  unsigned long      speed = *((unsigned long*)qh.substr(7, 4).c_str());

  this->hits = hits;
  this->address = Address(ip, port);
  this->speed = speed;

  qh.erase(0, 11);

  this->id_result = qh.substr(qh.size()-16);
  qh.erase(qh.size()-16, 16);

  if(this->id_result.size()!=16) cout << " WARNING WARNING WARNING " << endl;

  string::size_type pos;

  int hits_counter = 0;

  while(hits_counter < hits)
    {
      unsigned long index = *((unsigned long*)qh.substr(0, 4).c_str());
      unsigned long fsize = *((unsigned long*)qh.substr(4, 4).c_str());

      qh.erase(0, 8);

      pos = qh.find("\0\0");

      if(pos==string::npos) // delimiter not found => clear rest of query hit
	{
	  qh.erase();
	  break;
	}

      string fname = qh.substr(0, pos);
      qh.erase(0, pos+2);
      vQueryResult.push_back(QueryResult(index, fsize, fname));

      hits_counter++;
    }


  if(qh.size()>0)  // extended query hit
    this->trailer = qh;
  else
    this->trailer = "";
}



QueryHit::QueryHit(string header_id, int ttl, int hops, Address address, unsigned long speed,
		   string result_id, vector<QueryResult> vQueryResult)
{
  this->id = header_id;
  this->ttl = ttl;
  this->hops = hops;
  this->hits = vQueryResult.size();
  this->address = address;
  this->speed = speed;
  this->id_result = result_id;
  this->vQueryResult = vQueryResult;
  this->trailer="";
}

QueryHit::~QueryHit()
{
}
