/*
 * Copyright (c) 2001 Sun Microsystems, Inc. All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 * if any, must include the following acknowledgment:
 * "This product includes software developed by the
 * Sun Microsystems, Inc. for Project JXTA."
 * Alternately, this acknowledgment may appear in the software itself,
 * if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "Sun", "Sun Microsystems, Inc.", "JXTA" and "Project JXTA"
 * must not be used to endorse or promote products derived from this
 * software without prior written permission. For written
 * permission, please contact Project JXTA at http://www.jxta.org.
 *
 * 5. Products derived from this software may not be called "JXTA",
 * nor may "JXTA" appear in their name, without prior written
 * permission of Sun.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of Project JXTA. For more
 * information on Project JXTA, please see
 * <http://www.jxta.org/>.
 *
 * This license is based on the BSD license adopted by the Apache Foundation.
 *
 * $Id: GetDBStuff.java,v 1.1 2001/06/11 23:23:45 ddoolin Exp $
 */
package net.jxta.search.examples.jxtadb;

import java.io.*;
import java.net.*;
import java.util.*;



/* Dummy class for now.
 */

public class GetDBStuff implements Runnable {

    // stock cache
    private static Hashtable stockCache = new Hashtable();

  static {
    GetDBStuff sq = new GetDBStuff();
    Thread t = new Thread(sq);
    t.start();
  }

  public Collection getQuotes(String[] symbols) {
    Vector stocks = new Vector();
    for (int i = 0; i < symbols.length; i++) {
      String symbol = symbols[i];

      stocks.add(symbol);
    }
    return stocks;
  }


    public static void main(String args[])
        throws Exception
    {


    }

    public void run () {
      while (true) {
        try {
          Set keys = this.stockCache.keySet();
          Iterator it = keys.iterator();
          while (it.hasNext()) {
            String symbol = (String) it.next();
          }
          //System.out.println(new Date() + "\t:\t Yahoo Stock Quote");
          Thread.currentThread().sleep(5*60*1000);
        } catch (Exception e) {}
      }
    }

    public String getYahooQuote(String aSymbol)
    {
      try {
        aSymbol = aSymbol.toUpperCase();
        URL url = new URL(String.valueOf((new StringBuffer("http://finance.yahoo.com/q?s=")).append(aSymbol).append("&d=v1")));
        HttpURLConnection conn = (HttpURLConnection)url.openConnection();
        InputStreamReader in = new InputStreamReader(conn.getInputStream());
        BufferedReader br = new BufferedReader(in);
        String stopLine = String.valueOf((new StringBuffer("<td nowrap align=left><a href=\"/q?s=")).append(aSymbol).append("&d=t\">").append(aSymbol).append("</a></td>"));
        String line;
        while((line = br.readLine()) != null)
        {
            int i = line.indexOf(stopLine);
            if(i > -1)
            {
                int start = line.indexOf("<td nowrap>");
                int stop = line.indexOf("</td>", start);
                String quote = line.substring(start + 14, stop - 4);
                start = line.indexOf("<td nowrap>", stop);
                stop = stop = line.indexOf("</td>", start);
                String pointChange = line.substring(start + 11, stop);
                start = line.indexOf("<td nowrap>", stop);
                stop = stop = line.indexOf("</td>", start);
                String percentChange = line.substring(start + 11, stop);

                return "baz";
            }
        }
	return "f00";
      } catch (Exception e) {
	  return "bar";
      }
    }
}
