#!/bin/sh
if [ $# -ne 1 ]
then
  echo "usage: makebindist <version>"
  exit
fi

#build
ant clean
ant

#make dirs
dirname=websearch-$1-bin
rm -r $dirname
mkdir $dirname
mkdir $dirname/war
mkdir $dirname/lib
mkdir -p $dirname/goods/jxtasearch

#war
cp dist/*war $dirname/war

#jar files for the servlet container's lib dir
cp ../lib/xerces.jar $dirname/lib
cp ../lib/jxta.jar $dirname/lib
cp ../lib/jxtastarter.jar $dirname/lib
cp ../lib/goodsjpi.jar $dirname/lib
cp ../lib/goodslib.jar $dirname/lib

#copy the db configuration stuff
cp deployment/goodsrv.cfg $dirname/goods/jxtasearch
cp deployment/jxtasearch.cfg $dirname/goods/jxtasearch

#tar/gzip
tar cf $dirname'.tar' $dirname
gzip -f $dirname'.tar'
zip -r websearch.zip $dirname
mv $dirname ../search
#rm -rf $dirname
