@ECHO OFF

rem Script by bil@linuxstart.com
rem Edited by twh1@doc.ic.ac.uk, dave@c2labs.com, et.al.

echo Freenet installation
echo.
echo You are about to install a beta quality release of Freenet
echo This means that we *know* there are many bugs in it but we
echo need you to test it to let us know what they are.  Freenet is
echo being updated daily so it is recommended that you regularly 
echo download and install a new snapshot.  You should not be 
echo surprised if Freenet doesn't compile, or doesn't run - but
echo if this happens please email freenet-dev@lists.sourceforge.net
echo to let the development team know that there is a problem.
echo.
echo WARNING: This release of Freenet is a proof-of-concept to test
echo scalability and routing.  It does not (yet) provide any 
echo meaningful security!  Please do not insert or request any 
echo material which would place you at risk if your anonymity were 
echo compromised.  If you require strong anonymity, please wait
echo for the next release.  However, if you want to help us test 
echo and develop the system, please carry on!
echo.
echo You should already have run build.bat to compile Freenet.
echo If you have not done this yet, please press Ctrl/C now and
echo run build.bat first.
echo.

pause

if not "%1" == "" set FREENET_INSTALL_DIR=%1
if "%FREENET_INSTALL_DIR%" == "" set FREENET_INSTALL_DIR=C:\Freenet

echo.
echo Freenet will be installed in %FREENET_INSTALL_DIR%
echo.
echo To install in a different location, pass that location
echo as an argument, e.g., "install D:\MyFolder\Freenet".
echo.

pause

echo Installing Freenet in %FREENET_INSTALL_DIR%
      
mkdir "%FREENET_INSTALL_DIR%"

REM Copy sample.freenetrc and sample.fproxyrc only when no config files exist yet
if not exist "%FREENET_INSTALL_DIR%\freenet.ini" copy sample.freenetrc "%FREENET_INSTALL_DIR%\freenet.ini"
rem Windows doesn't like file names starting with a dot, workaround by renaming it
if not exist "%FREENET_INSTALL_DIR%\.fproxyrc"   copy sample.fproxyrc  "%FREENET_INSTALL_DIR%\fproxyrc"
if exist "%FREENET_INSTALL_DIR%\fproxyrc" ren "%FREENET_INSTALL_DIR%\fproxyrc" ".fproxyrc"

cd ..

xcopy *.class "%FREENET_INSTALL_DIR%\Freenet\*.class" /Q
xcopy .\client\*.class "%FREENET_INSTALL_DIR%\Freenet\client\*.class" /S /Q
xcopy .\contrib\fproxy\*.class "%FREENET_INSTALL_DIR%\Freenet\contrib\fproxy\*.class" /S /Q
xcopy .\crypt\*.class "%FREENET_INSTALL_DIR%\Freenet\crypt\*.class" /S /Q
xcopy .\keys\*.class "%FREENET_INSTALL_DIR%\Freenet\keys\*.class" /S /Q
xcopy .\message\*.class "%FREENET_INSTALL_DIR%\Freenet\message\*.class" /S /Q
xcopy .\node\*.class "%FREENET_INSTALL_DIR%\Freenet\node\*.class" /S /Q
xcopy .\presentation\*.class "%FREENET_INSTALL_DIR%\Freenet\presentation\*.class" /S /Q
xcopy .\support\*.class "%FREENET_INSTALL_DIR%\Freenet\support\*.class" /S /Q
xcopy .\thread\*.class "%FREENET_INSTALL_DIR%\Freenet\thread\*.class" /S /Q
xcopy .\transport\*.class "%FREENET_INSTALL_DIR%\Freenet\transport\*.class" /S /Q
xcopy .\servlet\*.class "%FREENET_INSTALL_DIR%\Freenet\servlet\*.class" /S /Q
xcopy .\scripts\*.class "%FREENET_INSTALL_DIR%\Freenet\scripts\*.class" /S /Q

copy README "%FREENET_INSTALL_DIR%\README.txt"
copy mime.types "%FREENET_INSTALL_DIR%\mimetype.txt"
REM GUI client nonfunction, not copy this
rem copy client\gui\Readme "%FREENET_INSTALL_DIR%\Freenet\client\gui\Readme"
rem copy client\gui\*.jpg "%FREENET_INSTALL_DIR%\Freenet\client\gui"
rem copy client\gui\*.gif "%FREENET_INSTALL_DIR%\Freenet\client\gui"

copy contrib\fproxy\gateway.html "%FREENET_INSTALL_DIR%\Freenet\contrib\fproxy\gateway.html"


echo Copying exe wrappers for freenet
cd scripts
   
copy FLaunch.ini "%FREENET_INSTALL_DIR%\FLaunch.ini"
copy fserve.exe "%FREENET_INSTALL_DIR%\fserve.exe"
copy fserve.exe "%FREENET_INSTALL_DIR%\frequest.exe"
copy fserve.exe "%FREENET_INSTALL_DIR%\finsert.exe"
copy fserve.exe "%FREENET_INSTALL_DIR%\cfgnode.exe"

rem Calling the Configuration script that creates the freenet.ini
%FREENET_INSTALL_DIR%\cfgnode.exe

echo.
echo Installation done.  
echo cd to %FREENET_INSTALL_DIR% and type 'fserve [options]' to start
echo the server, or 'fserve -help' for usage information.  Check freenet.log in
echo %FREENET_INSTALL_DIR% for any error messages once the server is running.
echo.
echo Type 'finsert' or 'frequest' to get usage information for the client.

set FREENET_INSTALL_DIR=

:_end
